/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package uoc.tfg.gui;

import java.io.IOException;
import java.net.URL;
import java.util.ResourceBundle;

import uoc.tfg.gui.views.MessageDialog;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.MenuItem;
import javafx.scene.paint.Color;
import javafx.stage.Modality;
import javafx.stage.Stage;

/**
 * FXML Controller class
 *
 * @author jsanzol
 */
public class MainPanelController implements Initializable {

	@FXML
    private ResourceBundle resources;

    @FXML
    private URL location;

    @FXML
    private MenuItem listAllWebFeedSubscription;

    @FXML
    private MenuItem newSeedMenuItem;

    @FXML
    private MenuItem newWebFeedSubscription;

    @FXML
    private MenuItem openCrawlerMenuItem;

    @FXML
    private MenuItem openWebFeedReader;

    @FXML
    private MenuItem searchSeedMenuItem;

    @FXML
    private MenuItem searchWebFeedSubscription;

    @FXML
    private MenuItem setStrategyMenuItem;


    /**
     * Initializes the controller class.
     */
    @Override
    public void initialize(URL url, ResourceBundle rb) {
        // TODO
    }
    
    /**
     * News Menu
     */

    @FXML
    private void actionNewWebFeedSubscription(ActionEvent event) {
    	Stage stage = new Stage();
    	stage.setTitle("New Web feed subscription");
    	Parent root = null;
		try {
			root = FXMLLoader.load(getClass().getResource(
					"/uoc/tfg/gui/views/webfeed/WebFeedSubscriptionView.fxml"));
		} catch (IOException e) {
			new MessageDialog(e);
		}
    	Scene scene = new Scene(root, 600, 400, Color.WHITE);    
    	stage.setScene(scene);
    	stage.setResizable(false);
    	stage.initModality(Modality.APPLICATION_MODAL);
    	stage.show();
    }
    
    @FXML
    void actionListAllWebFeedSubscription(ActionEvent event) {
    }


    @FXML
    private void actionSearchWebFeedSubscription(ActionEvent event) {
    	Stage stage = new Stage();
    	stage.setTitle("Search Web feed subscription");
    	Parent root = null;
		try {
			root = FXMLLoader.load(getClass().getResource(
					"/uoc/tfg/gui/views/webfeed/SearchWebFeedSubscriptionView.fxml"));
		} catch (IOException e) {
			new MessageDialog(e);
		}
    	Scene scene = new Scene(root, 600, 700, Color.WHITE);    
    	stage.setScene(scene);
    	stage.setResizable(false);
    	stage.initModality(Modality.APPLICATION_MODAL);
    	stage.show();
    }


    @FXML
    private void actionOpenWebFeedReader(ActionEvent event) {
        Stage stage = new Stage();
    	stage.setTitle("Web feed reader");
    	Parent root = null;
		try {
			root = FXMLLoader.load(getClass().getResource(
					"/uoc/tfg/gui/views/webfeed/WebFeedReaderView.fxml"));
		} catch (IOException e) {
			new MessageDialog(e);
		}
    	Scene scene = new Scene(root, 750, 400, Color.WHITE);    
    	stage.setScene(scene);
    	stage.show();
    }
    
    @FXML
    void actionNewSeedMenuItem(ActionEvent event) {
    	Stage stage = new Stage();
    	stage.setTitle("New Web crawling seed");
    	Parent root = null;
		try {
			root = FXMLLoader.load(getClass().getResource(
					"/uoc/tfg/gui/views/webcrawling/WebCrawlingSeedView.fxml"));
		} catch (IOException e) {
			new MessageDialog(e);
		}   
    	stage.setScene(new Scene(root, 600, 400, Color.WHITE));
    	stage.setResizable(false);
    	stage.initModality(Modality.APPLICATION_MODAL);
    	stage.show();
    }

    @FXML
    void actionSearchSeedMenuItem(ActionEvent event) {
    	Stage stage = new Stage();
    	stage.setTitle("Search Web crawling seed");
    	Parent root = null;
		try {
			root = FXMLLoader.load(getClass().getResource(
					"/uoc/tfg/gui/views/webcrawling/SearchWebCrawlingSeedView.fxml"));
		} catch (IOException e) {
			new MessageDialog(e);
		}   
    	stage.setScene(new Scene(root, 600, 700, Color.WHITE));
    	stage.setResizable(false);
    	stage.initModality(Modality.APPLICATION_MODAL);
    	stage.show();
    }

    @FXML
    void actionSetStrategyMenuItem(ActionEvent event) {
    	Stage stage = new Stage();
    	stage.setTitle("Web crawling strategy");
    	Parent root = null;
		try {
			root = FXMLLoader.load(getClass().getResource(
					"/uoc/tfg/gui/views/webcrawling/WebCrawlingStrategyView.fxml"));
		} catch (IOException e) {
			new MessageDialog(e);
		}   
    	stage.setScene(new Scene(root, 600, 580, Color.WHITE));
    	stage.setResizable(false);
    	stage.initModality(Modality.APPLICATION_MODAL);
    	stage.show();
    }
    
    @FXML
    void actionOpenCrawlerMenuItem(ActionEvent event) {
    	Stage stage = new Stage();
    	stage.setTitle("Web crawler");
    	Parent root = null;
		try {
			root = FXMLLoader.load(getClass().getResource(
					"/uoc/tfg/gui/views/webcrawling/WebCrawlerView.fxml"));
		} catch (IOException e) {
			new MessageDialog(e);
		}   
    	stage.setScene(new Scene(root, 900, 700, Color.WHITE));
    	stage.setResizable(true);
    	stage.show();
    }
    
    @FXML
    void actionOpenStreamingData(ActionEvent event) {
    	Stage stage = new Stage();
    	stage.setTitle("Streaming marketdata");
    	Parent root = null;
		try {
			root = FXMLLoader.load(getClass().getResource(
					"/uoc/tfg/gui/views/marketdata/StreamingAdapterView.fxml"));
		} catch (IOException e) {
			new MessageDialog(e);
		}   
    	stage.setScene(new Scene(root, 850, 917, Color.WHITE));
    	stage.setResizable(true);
    	stage.show();
    }
    
    @FXML
    void actionDownloadHistoricalData(ActionEvent event) {
    	
    	Stage stage = new Stage();
    	stage.setTitle("Download historical market data");
    	Parent root = null;
		try {
			root = FXMLLoader.load(getClass().getResource(
					"/uoc/tfg/gui/views/marketdata/DownloadYahooDataView.fxml"));
		} catch (IOException e) {
			new MessageDialog(e);
		}   
    	stage.setScene(new Scene(root, 600, 200, Color.WHITE));
    	stage.setResizable(false);
    	stage.initModality(Modality.APPLICATION_MODAL);
    	stage.show();
    }
    
    @FXML
    void actionNewIndex(ActionEvent event) {
    	
    	Stage stage = new Stage();
    	stage.setTitle("New index");
    	Parent root = null;
		try {
			root = FXMLLoader.load(getClass().getResource(
					"/uoc/tfg/gui/views/document/IndexView.fxml"));
		} catch (IOException e) {
			new MessageDialog(e);
		}   
    	stage.setScene(new Scene(root, 400, 300, Color.WHITE));
    	stage.setResizable(false);
    	stage.initModality(Modality.APPLICATION_MODAL);
    	stage.show();
    }
    
    @FXML
    void actionSearchIndex(ActionEvent event) {
    }
    
    @FXML
    void actionExploreIndex(ActionEvent event) {
    	
    	Stage stage = new Stage();
    	stage.setTitle("Document explorer");
    	Parent root = null;
		try {
			root = FXMLLoader.load(getClass().getResource(
					"/uoc/tfg/gui/views/document/IndexExplorerView.fxml"));
		} catch (IOException e) {
			new MessageDialog(e);
		}   
    	stage.setScene(new Scene(root, 800, 660, Color.WHITE));
    	stage.setResizable(true);
    	stage.show();
    }

    @FXML
    void actionNewCategorySetMenuItem(ActionEvent event) {
    	
    	Stage stage = new Stage();
    	stage.setTitle("Category set");
    	Parent root = null;
		try {
			root = FXMLLoader.load(getClass().getResource(
					"/uoc/tfg/gui/views/analysis/ClassSetView.fxml"));
		} catch (IOException e) {
			new MessageDialog(e);
		}   
    	stage.setScene(new Scene(root, 400, 480, Color.WHITE));
    	stage.setResizable(false);
    	stage.initModality(Modality.APPLICATION_MODAL);
    	stage.show();
    }
    
    @FXML
    void actionNewTokenCollection(ActionEvent event) {
    	
    	Stage stage = new Stage();
    	stage.setTitle("Token collection");
    	Parent root = null;
		try {
			root = FXMLLoader.load(getClass().getResource(
					"/uoc/tfg/gui/views/analysis/TokenCollectionView.fxml"));
		} catch (IOException e) {
			new MessageDialog(e);
		}   
    	stage.setScene(new Scene(root, 500, 400, Color.WHITE));
    	stage.setResizable(false);
    	stage.initModality(Modality.APPLICATION_MODAL);
    	stage.show();
    }

    @FXML
    void actionNewTrainingSet(ActionEvent event) {
    	
    	Stage stage = new Stage();
    	stage.setTitle("Document explorer");
    	Parent root = null;
		try {
			root = FXMLLoader.load(getClass().getResource(
					"/uoc/tfg/gui/views/document/IndexExplorerView.fxml"));
		} catch (IOException e) {
			new MessageDialog(e);
		}   
    	stage.setScene(new Scene(root, 800, 660, Color.WHITE));
    	stage.setResizable(true);
    	stage.show();
    }
    
}
