package uoc.tfg.gui.views;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;

import javafx.fxml.FXMLLoader;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.paint.Color;
import javafx.stage.Modality;
import javafx.stage.Stage;

/**
 * Trading platform
 * 
 * @author Javier Sanzol
 * 
 * 2012-09-07 v.1
 *
 */

public class MessageDialog extends Stage {
	
	private FXMLLoader fxmlLoader;
	private Parent root;
	private Scene scene;
	private String message;
	private Exception e;
	private String exceptionDetails;
	
	
	public MessageDialog(String message) {
		super();
		this.setMessage(message);
		this.initComponents();
	}
	
	public MessageDialog(Exception e) {
		super();
		this.e = e;
		this.setMessage(this.e.toString());
		StringWriter sw = new StringWriter();
		e.printStackTrace(new PrintWriter(sw));
		this.exceptionDetails = sw.toString();
		this.initComponents();
	}
	
	private void initComponents() {
		this.setTitle("Message dialog");
		fxmlLoader = new FXMLLoader(getClass().getResource("/uoc/tfg/gui/views/MessageDialogView.fxml"));
		root = null;
		try {
			root = (Parent)fxmlLoader.load();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}          
		MessageDialogViewController controller = fxmlLoader.<MessageDialogViewController>getController();
		controller.setParent(this);
		scene = new Scene(root, 400, 300, Color.WHITE);    
		this.setScene(scene);
		this.setResizable(false);
		this.initModality(Modality.APPLICATION_MODAL);
		this.show();
	}

	/**
	 * @return the message
	 */
	public String getMessage() {
		return message;
	}

	/**
	 * @param message2 the message to set
	 */
	public void setMessage(String message2) {
		this.message = message2;
	}

	/**
	 * @return the exceptionDetails
	 */
	public String getExceptionDetails() {
		return exceptionDetails;
	}

	/**
	 * @param exceptionDetails the exceptionDetails to set
	 */
	public void setExceptionDetails(String exceptionDetails) {
		this.exceptionDetails = exceptionDetails;
	}

	
	

}
