/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package uoc.tfg.gui.views.analysis;

import java.io.IOException;
import java.net.URL;
import java.util.ResourceBundle;

import uoc.tfg.exception.GuiException;
import uoc.tfg.gui.views.MessageDialog;
import uoc.tfg.gui.views.webfeed.SelectWebFeedURLViewController;
import uoc.tfg.invoke.analysis.CategorySetInvoke;
import uoc.tfg.invoke.webfeed.WebFeedReaderInvoke;
import uoc.tfg.model.news.webfeed.WebFeedURL;
import uoc.tfg.model.textanalysis.classification.Category;
import uoc.tfg.model.textanalysis.classification.CategorySet;
import javafx.beans.value.ObservableValue;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Node;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.TextField;
import javafx.scene.control.TableColumn.CellDataFeatures;
import javafx.scene.control.cell.TextFieldTableCell;
import javafx.scene.paint.Color;
import javafx.stage.Modality;
import javafx.stage.Stage;
import javafx.util.Callback;


public class ClassSetViewController implements Initializable {

	@FXML
    private ResourceBundle resources;

    @FXML
    private URL location;

    @FXML
    private Button acceptButton;

    @FXML
    private Button cancelButton;

    @FXML
    private TableColumn<ClassTableModel, String> classColumn;

    @FXML
    private TableView<ClassTableModel> classSetTableView;

    @FXML
    private TableColumn<ClassTableModel, String> descriptionColumn;

    @FXML
    private Button editButton;

    @FXML
    private TextField maxClassTextField;

    @FXML
    private TextField minClassTextField;

    @FXML
    private Button okButton;
    
    @FXML
    private TextField descriptionTextField;

    @FXML
    private TextField nameTextField;

    CategorySet categorySet;

    
    @Override
    public void initialize(URL url, ResourceBundle rb) {
    	
    	this.classColumn.setCellValueFactory(
    			new Callback<CellDataFeatures<ClassTableModel, String>, ObservableValue<String>>() {
    		public ObservableValue<String> call(CellDataFeatures<ClassTableModel, String> p) {
    			return p.getValue().valueProperty();
    		}
    	});
    	
    	this.descriptionColumn.setCellValueFactory(
    			new Callback<CellDataFeatures<ClassTableModel, String>, ObservableValue<String>>() {
    	     public ObservableValue<String> call(CellDataFeatures<ClassTableModel, String> p) {
    	         return p.getValue().nameProperty();
    	     }
    	});	
    }

    

    @FXML
    void accionAcceptButton(ActionEvent event) {
    	
    	String name = this.nameTextField.getText();
    	String description = this.descriptionTextField.getText();
    	
    	if(name.isEmpty() || description.isEmpty()) {
    		new MessageDialog(new GuiException(GuiException.FORM_NOT_COMPLETE));
    	} else {
    		this.categorySet.setName(name);
    		this.categorySet.setDescription(description);
    	}
    	
    	CategorySetInvoke.newCategorySet(this.categorySet);
    	
    	((Stage) ((Node)  event.getSource()).getScene().getWindow()).close();
    }

    @FXML
    void accionEditButton(ActionEvent event) {
    	
    	Stage stage = new Stage();
    	stage.setTitle("Category");
    	FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource(
    			"/uoc/tfg/gui/views/analysis/ClassView.fxml"));
    	Parent root = null;
		try {
			root = (Parent)fxmlLoader.load();
		} catch (IOException e) {
			new MessageDialog(e);
		}          
		ClassViewController controller = 
				fxmlLoader.<ClassViewController>getController();
    	controller.initialize(this.classSetTableView.getSelectionModel().getSelectedItem());
    	Scene scene = new Scene(root, 350, 40, Color.WHITE);    
    	stage.setScene(scene);
    	stage.setResizable(false);
    	stage.initModality(Modality.APPLICATION_MODAL);
    	stage.show();
    }

    @FXML
    void actionCancelButton(ActionEvent event) {
    	((Stage) ((Node)  event.getSource()).getScene().getWindow()).close();
    }

    @FXML
    void actionOkButton(ActionEvent event) {
    	
    	this.classSetTableView.getItems().clear();
    	
    	Integer min = Integer.valueOf(this.minClassTextField.getText());
    	Integer max = Integer.valueOf(this.maxClassTextField.getText());
    	
    	this.categorySet = new CategorySet(
    			this.nameTextField.getText(),
    			this.descriptionTextField.getText(),
    			new Category[(max.intValue()-min.intValue()+1)]);
    	
    	for(int i = min.intValue(); i<= max.intValue(); i++) {
    		
    		Category c = new Category("", i);
    		this.categorySet.addCategory(c, i-min.intValue());
    		this.classSetTableView.getItems().add(new ClassTableModel(c));
    	}
    }

    
}
