package uoc.tfg.gui.views.analysis;

import java.io.Serializable;

import javafx.beans.property.SimpleStringProperty;
import javafx.beans.property.StringProperty;

import uoc.tfg.model.textanalysis.classification.Category;

public class ClassTableModel implements Serializable {
	
	private static final long serialVersionUID = 6453075781087305757L;
	private Category cl;
	private StringProperty name = new SimpleStringProperty();
    private StringProperty value = new SimpleStringProperty();
    
    
	public ClassTableModel(Category cl) {
		this.cl = cl;
		this.setName(cl.getName());
		this.setValue(String.valueOf(cl.getValue()));
	}

    
	public final Category getCategory() {
		return cl;
	}

	public final void setCategory(Category cl) {
		this.cl = cl;
	}


	public final String getName() {
		return name.get();
	}


	public final void setName(String value) {
		this.name.set(value);
		this.cl.setName(value);
	}

	public StringProperty nameProperty() {
    	return name;
    }

	public final String getValue() {
		return value.get();
	}


	public final void setValue(String value) {
		this.value.set(value);
		this.cl.setValue(Integer.valueOf(value).intValue());
	}

	public StringProperty valueProperty() {
    	return value;
    }


}
