/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 08/01/2014
 *
 */
package uoc.tfg.gui.views.analysis;

import java.net.URL;
import java.util.ResourceBundle;

import uoc.tfg.invoke.analysis.CategorySetInvoke;
import uoc.tfg.model.textanalysis.classification.CategorySet;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.Node;
import javafx.scene.control.Button;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.TextField;
import javafx.scene.control.cell.PropertyValueFactory;
import javafx.stage.Stage;

public class SelectClassSetViewController implements Initializable {

	@FXML
    private ResourceBundle resources;

    @FXML
    private URL location;

    @FXML
    private Button acceptButton;

    @FXML
    private Button addButton;

    @FXML
    private Button cancelButton;

    @FXML
    private Button removeButton;

    @FXML
    private TableColumn<CategorySet, String> selectedColumn;

    @FXML
    private TableView<CategorySet> selectedTableView;

    @FXML
    private TableColumn<CategorySet, String> unselectedColumn;

    @FXML
    private TableView<CategorySet> unselectedTableView;
    
    private CategorySet catSet;
    
    private TextField textField;


	/* (non-Javadoc)
	 * @see javafx.fxml.Initializable#initialize(java.net.URL, java.util.ResourceBundle)
	 */
	@Override
	public void initialize(URL arg0, ResourceBundle arg1) {
		// TODO Auto-generated method stub

	}
	
	public void initialize(CategorySet catSet, TextField textField) {
		this.unselectedColumn.setCellValueFactory(
				new PropertyValueFactory<CategorySet, String>("name"));
		this.selectedColumn.setCellValueFactory(
				new PropertyValueFactory<CategorySet, String>("name"));
		
		this.unselectedTableView.getItems().addAll(CategorySetInvoke.getAllCategorySets());
		
		this.catSet = catSet;
		this.textField = textField;
	}
	
    @FXML
    void accionAcceptButton(ActionEvent event) {
    	
    	for(CategorySet cs: this.selectedTableView.getItems()) {
    		this.catSet.setName(cs.getName());
    		this.catSet.setDescription(cs.getDescription());
    		this.catSet.setCategories(cs.getCategories());
    	}
    	this.textField.setText(this.catSet.getName());
    	((Stage) ((Node)  event.getSource()).getScene().getWindow()).close();
    }
    
    @FXML
    void actionCancelButton(ActionEvent event) {
    	((Stage) ((Node)  event.getSource()).getScene().getWindow()).close();
    }

    @FXML
    void actionAddURLButton(ActionEvent event) {
    	if(!this.unselectedTableView.getSelectionModel().isEmpty()) {
    		CategorySet cs = this.unselectedTableView.getSelectionModel().getSelectedItem();
        	if(!this.selectedTableView.getItems().isEmpty()) {
        		this.unselectedTableView.getItems().add(this.selectedTableView.getItems().remove(0));
        	}
        	this.selectedTableView.getItems().add(cs);
        	this.unselectedTableView.getItems().remove(cs);
    	}
    }

    

    @FXML
    void actionRemoveURLButton(ActionEvent event) {
    	if(!this.selectedTableView.getSelectionModel().isEmpty()) {
    		CategorySet cs = this.selectedTableView.getSelectionModel().getSelectedItem();
        	this.unselectedTableView.getItems().add(cs);
        	this.selectedTableView.getItems().remove(cs);
    	}
    }

	
}

