/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 08/01/2014
 *
 */
package uoc.tfg.gui.views.analysis;

import java.net.URL;
import java.util.ResourceBundle;

import uoc.tfg.invoke.analysis.TokenCollectionInvoke;
import uoc.tfg.model.textanalysis.ITokenCollection;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.Node;
import javafx.scene.control.Button;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.TextField;
import javafx.scene.control.cell.PropertyValueFactory;
import javafx.stage.Stage;

public class SelectTokenCollectionViewController implements Initializable {

	@FXML
    private ResourceBundle resources;

    @FXML
    private URL location;

    @FXML
    private Button acceptButton;

    @FXML
    private Button addButton;

    @FXML
    private Button cancelButton;

    @FXML
    private Button removeButton;

    @FXML
    private TableColumn<ITokenCollection, String> selectedColumn;

    @FXML
    private TableView<ITokenCollection> selectedTableView;

    @FXML
    private TableColumn<ITokenCollection, String> unselectedColumn;

    @FXML
    private TableView<ITokenCollection> unselectedTableView;
    
    private ITokenCollection tokenCollection;
    
    private TextField textField;


	/* (non-Javadoc)
	 * @see javafx.fxml.Initializable#initialize(java.net.URL, java.util.ResourceBundle)
	 */
	@Override
	public void initialize(URL arg0, ResourceBundle arg1) {
		// TODO Auto-generated method stub

	}
	
	public void initialize(ITokenCollection tc, TextField textField) {
		this.unselectedColumn.setCellValueFactory(
				new PropertyValueFactory<ITokenCollection, String>("name"));
		this.selectedColumn.setCellValueFactory(
				new PropertyValueFactory<ITokenCollection, String>("name"));
		
		this.unselectedTableView.getItems().addAll(TokenCollectionInvoke.getAllTokenCollections());
		System.out.println(this.unselectedTableView.getItems().size());
		System.out.println(this.unselectedTableView.getItems().get(0).getName());
		this.tokenCollection = tc;
		this.textField = textField;
	}
	
    @FXML
    void accionAcceptButton(ActionEvent event) {
    	
    	for(ITokenCollection tc: this.selectedTableView.getItems()) {
    		this.tokenCollection.setName(tc.getName());
    		this.tokenCollection.setDescription(tc.getDescription());
    		this.tokenCollection.setTokens(tc.getTokens());
    	}
    	this.textField.setText(this.tokenCollection.getName());
    	((Stage) ((Node)  event.getSource()).getScene().getWindow()).close();
    }
    
    @FXML
    void actionCancelButton(ActionEvent event) {
    	((Stage) ((Node)  event.getSource()).getScene().getWindow()).close();
    }

    @FXML
    void actionAddURLButton(ActionEvent event) {
    	if(!this.unselectedTableView.getSelectionModel().isEmpty()) {
    		ITokenCollection tc = this.unselectedTableView.getSelectionModel().getSelectedItem();
        	if(!this.selectedTableView.getItems().isEmpty()) {
        		this.unselectedTableView.getItems().add(this.selectedTableView.getItems().remove(0));
        	}
        	this.selectedTableView.getItems().add(tc);
        	this.unselectedTableView.getItems().remove(tc);
    	}
    }

    

    @FXML
    void actionRemoveURLButton(ActionEvent event) {
    	if(!this.selectedTableView.getSelectionModel().isEmpty()) {
    		ITokenCollection tc = this.selectedTableView.getSelectionModel().getSelectedItem();
        	this.unselectedTableView.getItems().add(tc);
        	this.selectedTableView.getItems().remove(tc);
    	}
    }

	
}

