package uoc.tfg.gui.views.analysis;

import java.io.IOException;
import java.net.URL;
import java.util.ResourceBundle;

import uoc.tfg.exception.GuiException;
import uoc.tfg.gui.views.MessageDialog;
import uoc.tfg.invoke.analysis.TokenCollectionInvoke;
import uoc.tfg.model.textanalysis.ITokenCollection;
import uoc.tfg.model.textanalysis.SpanishTokenizer;
import uoc.tfg.model.textanalysis.TokenCollection;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.Node;
import javafx.scene.control.TextArea;
import javafx.scene.control.TextField;
import javafx.stage.Stage;

public class TokenCollectionViewController implements Initializable {

	@FXML
    private ResourceBundle resources;

    @FXML
    private URL location;

    @FXML
    private TextArea descriptionTextArea;

    @FXML
    private TextField nameTextField;

    @FXML
    private TextArea tokensTextArea;

    
    @Override
	public void initialize(URL arg0, ResourceBundle arg1) {
		// TODO Auto-generated method stub

	}

    @FXML
    void initialize() {
       
    }
	
    @FXML
    void actionAcceptButton(ActionEvent event) {
    	
    	String name = this.nameTextField.getText();
    	String description = this.descriptionTextArea.getText();
    	String tokens = this.tokensTextArea.getText();
    	
    	if(name.isEmpty() || tokens.isEmpty()) {
    		new MessageDialog(new GuiException(GuiException.FORM_NOT_COMPLETE));
    	} else {
    		
    		ITokenCollection collection = null;
    		try {
				collection = 
						new TokenCollection(new SpanishTokenizer().getTokens(tokens));
			} catch (IOException e) {
				new MessageDialog(e);
			}
    		if(collection != null) {
    			collection.setName(name);
    			collection.setDescription(description);
    			TokenCollectionInvoke.newTokenCollection(collection);
    		}
    	}
    	
    	((Stage) ((Node)  event.getSource()).getScene().getWindow()).close();
    }
    
    @FXML
    void actionCancelButton(ActionEvent event) {
    	((Stage) ((Node)  event.getSource()).getScene().getWindow()).close();
    }


}
