/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package uoc.tfg.gui.views.document;

import java.io.IOException;
import java.net.URL;
import java.util.ResourceBundle;

import org.apache.lucene.queryparser.classic.ParseException;

import uoc.tfg.exception.GuiException;
import uoc.tfg.gui.views.MessageDialog;
import uoc.tfg.gui.views.analysis.SelectClassSetViewController;
import uoc.tfg.gui.views.analysis.SelectClassViewController;
import uoc.tfg.gui.views.analysis.SelectTokenCollectionViewController;
import uoc.tfg.invoke.document.IndexExplorerInvoke;
import uoc.tfg.model.document.Index;
import uoc.tfg.model.textanalysis.ITokenCollection;
import uoc.tfg.model.textanalysis.TokenCollection;
import uoc.tfg.model.textanalysis.classification.CategorySet;

import javafx.beans.value.ObservableValue;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Node;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.ComboBox;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.TextField;
import javafx.scene.control.TableColumn.CellDataFeatures;
import javafx.scene.input.MouseEvent;
import javafx.scene.paint.Color;
import javafx.scene.text.Text;
import javafx.scene.web.WebEngine;
import javafx.scene.web.WebView;
import javafx.stage.Modality;
import javafx.stage.Stage;
import javafx.util.Callback;


public class IndexExplorerViewController implements Initializable {

    @FXML
    private ResourceBundle resources;

    @FXML
    private URL location;

    @FXML
    private Button acceptButton;

    @FXML
    private Button cancelButton;

    @FXML
    private Button classSetSelectButton;

    @FXML
    private TextField classSetTextField;

    @FXML
    private TableColumn<DocumentTableModel, String> dateSearchColumn;

    @FXML
    private TableColumn<DocumentTableModel, String> documentSearchColumn;

    @FXML
    private TableView<DocumentFieldTableModel> documentTableView;
    
    @FXML
    private TableColumn<DocumentFieldTableModel, String> fieldDocumentColumn;
    
    @FXML
    private TableColumn<DocumentFieldTableModel, String> valueDocumentColumn;

    @FXML
    private Text documentText;

    @FXML
    private TextField exploreIndexTextField;

    @FXML
    private ComboBox<?> field1ComboBox;

    @FXML
    private ComboBox<?> field2ComboBox;

    @FXML
    private ComboBox<?> field3ComboBox;

     @FXML
    private Text indexDocumentText;

    @FXML
    private Text indexNameText;

    @FXML
    private TableView<DocumentTableModel> indexTableView;

    @FXML
    private Text lastModifiedDocumentText;

    @FXML
    private TableColumn<DocumentTableModel, String> lastModifiedIndexColumn;

    @FXML
    private Text lastModifiedText;

    @FXML
    private ComboBox<?> logical1ComboBox;

    @FXML
    private ComboBox<?> logical2ComboBox;
    
    @FXML
    private ComboBox<?> logical3ComboBox;

    @FXML
    private Text numTermsDocumentText;

    @FXML
    private Text numberDocsText;

    @FXML
    private Text numberTermsText;

    @FXML
    private TextField query1TextField;

    @FXML
    private TextField query2TextField;

    @FXML
    private TextField query3TextField;

    @FXML
    private Button resetButton;

    @FXML
    private Button searchButton;

    @FXML
    private TableView<DocumentTableModel> searchTableView;

    @FXML
    private Button selectIndexButton;

    @FXML
    private TableView<DocumentTableModel> trainingSetTableView;

    @FXML
    private TableColumn<DocumentTableModel, String> documentTrainingSetColumn;
    
    @FXML
    private TableColumn<DocumentTableModel, String> dateTrainingSetColumn;
    
    @FXML
    private TableColumn<DocumentTableModel, String> classTrainingSetColumn;
    
    @FXML
    private TableColumn<DocumentTableModel, String> titleIndexColumn;

    @FXML
    private Button tokenCollectionSelectButton;

    @FXML
    private TextField tokenCollectionTextField;

    @FXML
    private TableColumn<DocumentTableModel, String> urlIndexColumn;

    @FXML
    private TableColumn<DocumentTableModel, String> urlSearchColumn;

    @FXML
    private WebView documentWebView;
    
    private Index index = new Index();
    
    private CategorySet catSet = new CategorySet();
    
    private ITokenCollection tokenCollection = new TokenCollection();

    private IndexExplorerInvoke indexExplorerInvoke;

    
    @Override
    public void initialize(URL url, ResourceBundle rb) {
    	
    	this.titleIndexColumn.setCellValueFactory(
    			new Callback<CellDataFeatures<DocumentTableModel, String>, ObservableValue<String>>() {
    		public ObservableValue<String> call(CellDataFeatures<DocumentTableModel, String> p) {
    			return p.getValue().titleProperty();
    		}
    	});
    	
    	this.lastModifiedIndexColumn.setCellValueFactory(
    			new Callback<CellDataFeatures<DocumentTableModel, String>, ObservableValue<String>>() {
    		public ObservableValue<String> call(CellDataFeatures<DocumentTableModel, String> p) {
    			return p.getValue().dateProperty();
    		}
    	});
    	
    	this.urlIndexColumn.setCellValueFactory(
    			new Callback<CellDataFeatures<DocumentTableModel, String>, ObservableValue<String>>() {
    		public ObservableValue<String> call(CellDataFeatures<DocumentTableModel, String> p) {
    			return p.getValue().urlProperty();
    		}
    	});
    	
    	this.fieldDocumentColumn.setCellValueFactory(
    			new Callback<CellDataFeatures<DocumentFieldTableModel, String>, ObservableValue<String>>() {
    		public ObservableValue<String> call(CellDataFeatures<DocumentFieldTableModel, String> p) {
    			return p.getValue().fieldProperty();
    		}
    	});
    	
    	this.valueDocumentColumn.setCellValueFactory(
    			new Callback<CellDataFeatures<DocumentFieldTableModel, String>, ObservableValue<String>>() {
    		public ObservableValue<String> call(CellDataFeatures<DocumentFieldTableModel, String> p) {
    			return p.getValue().valueProperty();
    		}
    	});
    	
    	this.documentSearchColumn.setCellValueFactory(
    			new Callback<CellDataFeatures<DocumentTableModel, String>, ObservableValue<String>>() {
    		public ObservableValue<String> call(CellDataFeatures<DocumentTableModel, String> p) {
    			return p.getValue().titleProperty();
    		}
    	});
    	
    	this.dateSearchColumn.setCellValueFactory(
    			new Callback<CellDataFeatures<DocumentTableModel, String>, ObservableValue<String>>() {
    		public ObservableValue<String> call(CellDataFeatures<DocumentTableModel, String> p) {
    			return p.getValue().dateProperty();
    		}
    	});
    	
    	this.urlSearchColumn.setCellValueFactory(
    			new Callback<CellDataFeatures<DocumentTableModel, String>, ObservableValue<String>>() {
    		public ObservableValue<String> call(CellDataFeatures<DocumentTableModel, String> p) {
    			return p.getValue().urlProperty();
    		}
    	});
    	
    	this.documentTrainingSetColumn.setCellValueFactory(
    			new Callback<CellDataFeatures<DocumentTableModel, String>, ObservableValue<String>>() {
    		public ObservableValue<String> call(CellDataFeatures<DocumentTableModel, String> p) {
    			return p.getValue().titleProperty();
    		}
    	});
    	
    	this.dateTrainingSetColumn.setCellValueFactory(
    			new Callback<CellDataFeatures<DocumentTableModel, String>, ObservableValue<String>>() {
    		public ObservableValue<String> call(CellDataFeatures<DocumentTableModel, String> p) {
    			return p.getValue().dateProperty();
    		}
    	});
    	
    	this.classTrainingSetColumn.setCellValueFactory(
    			new Callback<CellDataFeatures<DocumentTableModel, String>, ObservableValue<String>>() {
    		public ObservableValue<String> call(CellDataFeatures<DocumentTableModel, String> p) {
    			return p.getValue().categoryNameProperty();
    		}
    	});
    	
    }
    
    
    @FXML
    void accionSearchButton(ActionEvent event) {
    	
    	if(this.indexExplorerInvoke == null) {
    		try {
    			this.indexExplorerInvoke  = new IndexExplorerInvoke(index);
    		} catch (IOException e) {
    			new MessageDialog(e);
    		}
    	}
    	
    	String[] logicals = new String[3];
    	String[] fields = new String[3];
    	String[] queries = new String[3];
    	
    	if(this.logical1ComboBox.getSelectionModel().getSelectedItem() != null)
    		logicals[0] = this.logical1ComboBox.getSelectionModel().getSelectedItem().toString();
    	if(this.logical2ComboBox.getSelectionModel().getSelectedItem() != null)
    		logicals[1] = this.logical1ComboBox.getSelectionModel().getSelectedItem().toString();
    	if(this.logical3ComboBox.getSelectionModel().getSelectedItem() != null)
    		logicals[2] = this.logical1ComboBox.getSelectionModel().getSelectedItem().toString();
    	
    	if(this.field1ComboBox.getSelectionModel().getSelectedItem() != null)
    		fields[0] = this.field1ComboBox.getSelectionModel().getSelectedItem().toString();
    	if(this.field2ComboBox.getSelectionModel().getSelectedItem() != null)
    		fields[1] = this.field2ComboBox.getSelectionModel().getSelectedItem().toString();
    	if(this.field3ComboBox.getSelectionModel().getSelectedItem() != null)
    		fields[2] = this.field3ComboBox.getSelectionModel().getSelectedItem().toString();
    	
    	if(!this.query1TextField.getText().isEmpty())
    		queries[0] = this.query1TextField.getText();
    	if(!this.query2TextField.getText().isEmpty())
    		queries[1] = this.query2TextField.getText();
    	if(!this.query3TextField.getText().isEmpty())
    		queries[2] = this.query3TextField.getText();
    	
    	int i = 0;
    	for(i=0;i<3;i++) {
    		if(queries[i] == null) break;
    	}
    	
    	String[] logicalsCopy = new String[i];
    	String[] fieldsCopy = new String[i];
    	String[] queriesCopy = new String[i];
    	
    	System.arraycopy(logicals, 0, logicalsCopy, 0, i);
    	System.arraycopy(fields, 0, fieldsCopy, 0, i);
    	System.arraycopy(queries, 0, queriesCopy, 0, i);
    	
    	try {
			this.indexExplorerInvoke.searchDocuments(fieldsCopy, queriesCopy, logicalsCopy);
		} catch (ParseException | IOException e) {
			new MessageDialog(e);
		}
    }

    @FXML
    void actionResetButton(ActionEvent event) {
    	
    	this.logical1ComboBox.getSelectionModel().select(null);
    	this.logical2ComboBox.getSelectionModel().select(null);
    	this.logical3ComboBox.getSelectionModel().select(null);
    	this.field1ComboBox.getSelectionModel().select(null);
    	this.field2ComboBox.getSelectionModel().select(null);
    	this.field3ComboBox.getSelectionModel().select(null);
    	this.query1TextField.setText(null);
    	this.query2TextField.setText(null);
    	this.query3TextField.setText(null);
    }
    
    @FXML
    void actionSelectIndexButton(ActionEvent event) {
    	
    	Stage stage = new Stage();
    	stage.setTitle("Select index");
    	FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource(
    			"/uoc/tfg/gui/views/document/SelectIndexView.fxml"));
    	Parent root = null;
		try {
			root = (Parent)fxmlLoader.load();
		} catch (IOException e) {
			new MessageDialog(e);
		}          
		SelectIndexViewController controller = 
				fxmlLoader.<SelectIndexViewController>getController();
    	controller.initialize(this.index, this.exploreIndexTextField);
    	Scene scene = new Scene(root, 600, 400, Color.WHITE);   
    	stage.setScene(scene);
    	stage.setResizable(false);
    	stage.initModality(Modality.APPLICATION_MODAL);
    	stage.show();
    }
    
    @FXML
    void actionLoadIndexButton(ActionEvent event) {
    	if(this.indexExplorerInvoke == null) {
    		try {
    			this.indexExplorerInvoke  = new IndexExplorerInvoke(index);
    		} catch (IOException e) {
    			new MessageDialog(e);
    		}
    	}
    	
    	try {
			this.indexTableView.setItems(indexExplorerInvoke.getDocuments());
			this.trainingSetTableView.setItems(indexExplorerInvoke.getDocuments());
		} catch (IOException e) {
			new MessageDialog(e);
		}
    	
    	this.searchTableView.setItems(this.indexExplorerInvoke.getSearchDocuments());
    	
    	String indexName = this.indexNameText.getText();
    	this.indexNameText.setText(
    			indexName + " " + this.index.getName());
    	this.indexDocumentText.setText(
    			indexName + " " + this.index.getName());
    	String numDocs = this.numberDocsText.getText();
    	try {
			this.numberDocsText.setText(
					numDocs + " " + String.valueOf(this.indexExplorerInvoke.getNumDocuments()));
		} catch (IOException e) {
			new MessageDialog(e);
		}
    }

    @FXML
    void actionOnSelectEntryIndex(MouseEvent event) {
    	
    	DocumentTableModel doc = this.indexTableView.getSelectionModel().getSelectedItem();
    	
    	if(doc != null) {
    		this.documentTableView.setItems(doc.getFieldModels());
        	
        	WebEngine webEngine = this.documentWebView.getEngine();
        	webEngine.load(doc.getUrl());
    	}
    }
    
    @FXML
    void actionOnSelectEntrySearch(MouseEvent event) {
    	
    	DocumentTableModel doc = this.searchTableView.getSelectionModel().getSelectedItem();
    	
    	if(doc != null) {
    		this.documentTableView.setItems(doc.getFieldModels());
        	
        	WebEngine webEngine = this.documentWebView.getEngine();
        	webEngine.load(doc.getUrl());
    	}
    }
    
    @FXML
    void actionOnSelectEntryTrainingSet(MouseEvent event) {
    	
    	DocumentTableModel doc = this.trainingSetTableView.getSelectionModel().getSelectedItem();
    	
    	if(doc != null) {
    		this.documentTableView.setItems(doc.getFieldModels());
        	
        	WebEngine webEngine = this.documentWebView.getEngine();
        	webEngine.load(doc.getUrl());
    	}
    }
    
    @FXML
    void actionClassSetSelectButton(ActionEvent event) {
    	
    	Stage stage = new Stage();
    	stage.setTitle("Select classification set");
    	FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource(
    			"/uoc/tfg/gui/views/analysis/SelectClassSetView.fxml"));
    	Parent root = null;
		try {
			root = (Parent)fxmlLoader.load();
		} catch (IOException e) {
			new MessageDialog(e);
		}          
		SelectClassSetViewController controller = 
				fxmlLoader.<SelectClassSetViewController>getController();
    	controller.initialize(this.catSet, this.classSetTextField);
    	Scene scene = new Scene(root, 600, 400, Color.WHITE);   
    	stage.setScene(scene);
    	stage.setResizable(false);
    	stage.initModality(Modality.APPLICATION_MODAL);
    	stage.show();
    }

    @FXML
    void actionTokenCollectionSelectButton(ActionEvent event) {
    	
    	Stage stage = new Stage();
    	stage.setTitle("Select token collection");
    	FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource(
    			"/uoc/tfg/gui/views/analysis/SelectTokenCollectionView.fxml"));
    	Parent root = null;
		try {
			root = (Parent)fxmlLoader.load();
		} catch (IOException e) {
			new MessageDialog(e);
		}          
		SelectTokenCollectionViewController controller = 
				fxmlLoader.<SelectTokenCollectionViewController>getController();
    	controller.initialize(this.tokenCollection, this.tokenCollectionTextField);
    	Scene scene = new Scene(root, 600, 400, Color.WHITE);   
    	stage.setScene(scene);
    	stage.setResizable(false);
    	stage.initModality(Modality.APPLICATION_MODAL);
    	stage.show();
    }
    
    @FXML
    void actionClassifyDocumentButton(ActionEvent event) {
    	
    	DocumentTableModel doc = this.trainingSetTableView.getSelectionModel().getSelectedItem();
    	
    	if(doc != null) {
    		Stage stage = new Stage();
        	stage.setTitle("Assign Category");
        	FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource(
        			"/uoc/tfg/gui/views/analysis/SelectClassView.fxml"));
        	Parent root = null;
    		try {
    			root = (Parent)fxmlLoader.load();
    		} catch (IOException e) {
    			new MessageDialog(e);
    		}          
    		SelectClassViewController controller = 
    				fxmlLoader.<SelectClassViewController>getController();
    		if(this.catSet != null)
    			controller.initialize(doc, this.catSet);
        	Scene scene = new Scene(root, 350, 40, Color.WHITE);    
        	stage.setScene(scene);
        	stage.setResizable(false);
        	stage.initModality(Modality.APPLICATION_MODAL);
        	stage.show();
    	} else {
    		new MessageDialog(GuiException.NOT_SELECTION);
    	}
    }
    
    @FXML
    void actionRemoveDocumentButton(ActionEvent event) {
    	
    	DocumentTableModel doc = this.indexTableView.getSelectionModel().getSelectedItem();
    	
    	if(doc != null) {
    		this.trainingSetTableView.getItems().remove(doc);
    	} else {
    		new MessageDialog(GuiException.NOT_SELECTION);
    	}
    }
    

    @FXML
    void accionAcceptButton(ActionEvent event) {
    }
    
    @FXML
    void actionCancelButton(ActionEvent event) {
    	((Stage) ((Node)  event.getSource()).getScene().getWindow()).close();
    }

    
    
}
