package uoc.tfg.gui.views.document;

import java.io.Serializable;

import uoc.tfg.model.document.Index;
import javafx.beans.property.SimpleStringProperty;
import javafx.beans.property.StringProperty;

public class IndexTreeModel implements Serializable {
	
	private static final long serialVersionUID = 8934507731875098962L;
	private final Index index;
	private final StringProperty name = new SimpleStringProperty();
    private final StringProperty description = new SimpleStringProperty();
    private final StringProperty path = new SimpleStringProperty();
 
    
    
    public IndexTreeModel(Index index) {
		this.index = index;
		this.setName(this.index.getName());
		this.setDescription(this.index.getDescription());
		this.setPath(this.index.getPath().getAbsolutePath());
	}


	public final String getName(){
    	return name.get();
    }
 
    
    public final void setName(String value){
    	name.set(value);
    }
 
   
    public StringProperty nameProperty() {
    	return name;
    }
    
    public final String getDescription(){
    	return description.get();
    }
 
    
    public final void setDescription(String value){
    	description.set(value);
    }
 
   
    public StringProperty descriptionProperty() {
    	return description;
    }
    
    public final String getPath(){
    	return path.get();
    }
 
    
    public final void setPath(String value){
    	path.set(value);
    }
 
   
    public StringProperty pathProperty() {
    	return path;
    }

}
