/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package uoc.tfg.gui.views.document;

import java.net.URL;
import java.util.ResourceBundle;

import uoc.tfg.exception.GuiException;
import uoc.tfg.gui.views.MessageDialog;
import uoc.tfg.invoke.document.IndexInvoke;
import uoc.tfg.model.document.Index;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.Node;
import javafx.scene.control.Button;
import javafx.scene.control.TextArea;
import javafx.scene.control.TextField;
import javafx.stage.Stage;


public class IndexViewController implements Initializable{

    @FXML
    private ResourceBundle resources;

    @FXML
    private URL location;

    @FXML
    private Button acceptButton;

    @FXML
    private Button cancelButton;

    @FXML
    private TextArea descriptionTextArea;

    @FXML
    private TextField nameTextField;

    @FXML
    private TextField pathTextField;
    
    private boolean isNewMode = true;
    
    private Index index = new Index();

    /**
     * Initializes the controller class.
     */
    @Override
    public void initialize(URL url, ResourceBundle rb) {
        // TODO
    } 
    
    public void initialize(Index i, boolean newMode) {
    	this.isNewMode = newMode;
    	if(this.isNewMode) {
    		this.index = i;
    	} else {
    		this.nameTextField.setText(i.getName().toString());
        	this.descriptionTextArea.setText(i.getDescription());
        	this.pathTextField.setText(i.getPath().getAbsolutePath());
    	}	
    }
    
    @FXML
    void accionAcceptButton(ActionEvent event) {
    	
    	String name = this.nameTextField.getText();
    	String description = this.descriptionTextArea.getText();
    	String path = this.pathTextField.getText();
    	
    	if(path.isEmpty() || name.isEmpty() || description.isEmpty()) {
    		new MessageDialog(new GuiException(GuiException.FORM_NOT_COMPLETE));
    	} else {
    		Index idx = null;
			
    		if(this.isNewMode) {
    			idx = new Index(name, description, path);
    			IndexInvoke.newIndex(idx);
    			
        		this.index.setName(idx.getName());
        		this.index.setDescription(idx.getDescription());
        		this.index.setPath(idx.getPath());
        		
    		} else {
    			this.index.setName(name);
        		this.index.setDescription(description);
        		IndexInvoke.editIndex(this.index);
    		}
    		  		
        	
    		((Stage) ((Node)  event.getSource()).getScene().getWindow()).close();
    	}
    }

    @FXML
    void actionCancelButton(ActionEvent event) {
    	((Stage) ((Node)  event.getSource()).getScene().getWindow()).close();
    }

    
}
