/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 08/01/2014
 *
 */
package uoc.tfg.gui.views.document;

import java.net.URL;
import java.util.ResourceBundle;

import uoc.tfg.gui.views.webcrawling.WebCrawlingStrategyViewController;
import uoc.tfg.invoke.document.IndexInvoke;
import uoc.tfg.model.document.Index;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.Node;
import javafx.scene.control.Button;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.TextField;
import javafx.scene.control.cell.PropertyValueFactory;
import javafx.stage.Stage;

public class SelectIndexViewController implements Initializable {

	@FXML
    private ResourceBundle resources;

    @FXML
    private URL location;

    @FXML
    private Button acceptButton;

    @FXML
    private Button addButton;

    @FXML
    private Button cancelButton;

    @FXML
    private Button removeButton;

    @FXML
    private TableColumn<Index, String> selectedColumn;

    @FXML
    private TableView<Index> selectedTableView;

    @FXML
    private TableColumn<Index, String> unselectedColumn;

    @FXML
    private TableView<Index> unselectedTableView;
    
    private Index index;
    
    private TextField indexTextField;


	/* (non-Javadoc)
	 * @see javafx.fxml.Initializable#initialize(java.net.URL, java.util.ResourceBundle)
	 */
	@Override
	public void initialize(URL arg0, ResourceBundle arg1) {
		// TODO Auto-generated method stub

	}
	
	public void initialize(Index index, TextField indexTextField) {
		this.unselectedColumn.setCellValueFactory(
				new PropertyValueFactory<Index, String>("name"));
		this.selectedColumn.setCellValueFactory(
				new PropertyValueFactory<Index, String>("name"));
		
		this.unselectedTableView.getItems().addAll(IndexInvoke.getAllIndex());
		
		this.index = index;
		this.indexTextField = indexTextField;
	}
	
	/**
	 * 
	 * @param iwfr
	 * @param stv
	 */
	public void initialize(WebCrawlingStrategyViewController wcsvc) {
		
		
	}
	
    @FXML
    void accionAcceptButton(ActionEvent event) {
    	
    	for(Index i: this.selectedTableView.getItems()) {
    		this.index.setPath(i.getPath());
    		this.index.setName(i.getName());
    		this.index.setDescription(i.getDescription());
    	}
    	this.indexTextField.setText(this.index.getName());
    	((Stage) ((Node)  event.getSource()).getScene().getWindow()).close();
    }
    
    @FXML
    void actionCancelButton(ActionEvent event) {
    	((Stage) ((Node)  event.getSource()).getScene().getWindow()).close();
    }

    @FXML
    void actionAddURLButton(ActionEvent event) {
    	if(!this.unselectedTableView.getSelectionModel().isEmpty()) {
    		Index i = this.unselectedTableView.getSelectionModel().getSelectedItem();
        	if(!this.selectedTableView.getItems().isEmpty()) {
        		this.unselectedTableView.getItems().add(this.selectedTableView.getItems().remove(0));
        	}
        	this.selectedTableView.getItems().add(i);
        	this.unselectedTableView.getItems().remove(i);
    	}
    }

    

    @FXML
    void actionRemoveURLButton(ActionEvent event) {
    	if(!this.selectedTableView.getSelectionModel().isEmpty()) {
    		Index i = this.selectedTableView.getSelectionModel().getSelectedItem();
        	this.unselectedTableView.getItems().add(i);
        	this.selectedTableView.getItems().remove(i);
    	}
    }	

}

