package uoc.tfg.gui.views.marketdata;

import java.net.URL;
import java.util.ResourceBundle;

import uoc.tfg.exception.GuiException;
import uoc.tfg.gui.views.MessageDialog;
import uoc.tfg.invoke.marketdata.MarketdataYahooInvoke;
import uoc.tfg.model.marketdata.yahoo.DownloadYahooInfo;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.Node;
import javafx.scene.control.Button;
import javafx.scene.control.ComboBox;
import javafx.scene.control.TextField;
import javafx.stage.Stage;

public class DownloadYahooDataViewController implements Initializable {

	
	@FXML
    private ResourceBundle resources;

    @FXML
    private URL location;

    @FXML
    private Button acceptButton;

    @FXML
    private Button cancelButton;

    @FXML
    private ComboBox<String> dataFrequencyComboBox;

    @FXML
    private TextField dayFrom;

    @FXML
    private TextField dayTo;

    @FXML
    private TextField monthFrom;

    @FXML
    private TextField monthTo;

    @FXML
    private TextField symbolTextField;

    @FXML
    private TextField yearFrom;

    @FXML
    private TextField yearTo;
    
    private DownloadYahooInfo info = new DownloadYahooInfo();


    
	@Override
	public void initialize(URL arg0, ResourceBundle arg1) {
		// TODO Auto-generated method stub

	}
	
	
	@FXML
    void accionAcceptButton(ActionEvent event) {
		
		String fromDate = "&a=" + this.monthFrom.getText() + "&b=" + this.dayFrom.getText()+ "&c=" +this.yearFrom.getText();
    	String toDate = "&d=" + this.monthTo.getText() + "&e=" + this.dayTo.getText()+ "&f=" +this.yearTo.getText();;
    	String frequency = (String) (this.dataFrequencyComboBox.getValue());
    	String symbol = this.symbolTextField.getText();
    	
    	if(fromDate.isEmpty() || toDate.isEmpty() || frequency.isEmpty() || symbol.isEmpty()) {
    		new MessageDialog(new GuiException(GuiException.FORM_NOT_COMPLETE));
    	} else {
    		
    		this.info.setStartDate(fromDate);
    		this.info.setEndDate(toDate);
    		this.info.setFrequency(frequency);
    		this.info.setSymbol(symbol);
    	}
    	
    	MarketdataYahooInvoke.downloadYahooData(info);
		
		((Stage) ((Node)  event.getSource()).getScene().getWindow()).close();
    }

    @FXML
    void actionCancelButton(ActionEvent event) {
    	((Stage) ((Node)  event.getSource()).getScene().getWindow()).close();
    }

}
