package uoc.tfg.gui.views.marketdata;

import java.io.Serializable;

import com.lightstreamer.ls_client.UpdateInfo;

import javafx.beans.property.SimpleStringProperty;
import javafx.beans.property.StringProperty;

public class MarketDataTableModel implements Serializable {
	
	private static final long serialVersionUID = -8858497383096424198L;
	private StringProperty symbol = new SimpleStringProperty();
    private StringProperty price = new SimpleStringProperty();
    private StringProperty varP = new SimpleStringProperty();
    private StringProperty varV = new SimpleStringProperty();
    private StringProperty max = new SimpleStringProperty();
    private StringProperty min = new SimpleStringProperty();
    private StringProperty volumen = new SimpleStringProperty();
    private StringProperty date = new SimpleStringProperty();
    
	
	public MarketDataTableModel(String symbol) {
		this.setSymbol(symbol);
	}
	
	
	
	public final String getSymbol() {
		return symbol.get();
	}



	public final void setSymbol(String value) {
		this.symbol.set(value);
	}

	public StringProperty symbolProperty() {
    	return symbol;
    }

	public final String getPrice() {
		return price.get();
	}



	public final void setPrice(String value) {
		this.price.set(value);
	}

	public StringProperty priceProperty() {
    	return price;
    }

	public final String getVarP() {
		return varP.get();
	}



	public final void setVarP(String value) {
		this.varP.set(value);
	}

	public StringProperty varPProperty() {
    	return varP;
    }

	public final String getVarV() {
		return varV.get();
	}



	public final void setVarV(String value) {
		this.varV.set(value);
	}

	public StringProperty varVProperty() {
    	return varV;
    }

	public final String getMax() {
		return max.get();
	}



	public final void setMax(String value) {
		this.max.set(value);
	}

	public StringProperty maxProperty() {
    	return max;
    }

	public final String getMin() {
		return min.get();
	}



	public final void setMin(String value) {
		this.min.set(value);
	}

	public StringProperty minProperty() {
    	return min;
    }

	public final String getVolumen() {
		return volumen.get();
	}



	public final void setVolumen(String value) {
		this.volumen.set(value);
	}

	public StringProperty volumenProperty() {
    	return volumen;
    }

	public final String getDate() {
		return date.get();
	}



	public final void setDate(String value) {
		this.date.set(value);
	}

	public StringProperty dateProperty() {
    	return date;
    }
	
	public void setData(UpdateInfo updateInfo) {
		this.setPrice(updateInfo.getNewValue(1));
		this.setVarP(updateInfo.getNewValue(2));
		this.setVarV(updateInfo.getNewValue(3));
		this.setMax(updateInfo.getNewValue(4));
		this.setMin(updateInfo.getNewValue(5));
		this.setVolumen(updateInfo.getNewValue(6));
		this.setDate(updateInfo.getNewValue(7));
	}

}
