/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 08/01/2014
 *
 */
package uoc.tfg.gui.views.marketdata;

import java.net.URL;
import java.util.ResourceBundle;

import uoc.tfg.gui.views.webcrawling.WebCrawlingStrategyViewController;
import uoc.tfg.invoke.marketdata.MarketdataLSInvoke;
import uoc.tfg.jpa.marketdata.LightstreamerJPA;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.Node;
import javafx.scene.control.Button;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.TextField;
import javafx.scene.control.cell.PropertyValueFactory;
import javafx.stage.Stage;

public class SelectStreamingConnectionViewController implements Initializable {

	@FXML
    private ResourceBundle resources;

    @FXML
    private URL location;

    @FXML
    private Button acceptButton;

    @FXML
    private Button addButton;

    @FXML
    private Button cancelButton;

    @FXML
    private Button removeButton;

    @FXML
    private TableColumn<LightstreamerJPA, String> selectedColumn;

    @FXML
    private TableView<LightstreamerJPA> selectedTableView;

    @FXML
    private TableColumn<LightstreamerJPA, String> unselectedColumn;

    @FXML
    private TableView<LightstreamerJPA> unselectedTableView;
    
    private LightstreamerJPA server;
    
    private TextField serverTextField;


	/* (non-Javadoc)
	 * @see javafx.fxml.Initializable#initialize(java.net.URL, java.util.ResourceBundle)
	 */
	@Override
	public void initialize(URL arg0, ResourceBundle arg1) {
		// TODO Auto-generated method stub

	}
	
	public void initialize(LightstreamerJPA server, TextField serverTextField) {
		this.unselectedColumn.setCellValueFactory(
				new PropertyValueFactory<LightstreamerJPA, String>("name"));
		this.selectedColumn.setCellValueFactory(
				new PropertyValueFactory<LightstreamerJPA, String>("name"));
		
		this.unselectedTableView.getItems().addAll(new MarketdataLSInvoke().getAllServer());
		
		this.server = server;
		this.serverTextField = serverTextField;
	}
	
	/**
	 * 
	 * @param iwfr
	 * @param stv
	 */
	public void initialize(WebCrawlingStrategyViewController wcsvc) {
		
		
	}
	
    @FXML
    void accionAcceptButton(ActionEvent event) {
    	
    	for(LightstreamerJPA i: this.selectedTableView.getItems()) {
    		this.serverTextField.setText(i.getName());
    	}
    	
    	((Stage) ((Node)  event.getSource()).getScene().getWindow()).close();
    }
    
    @FXML
    void actionCancelButton(ActionEvent event) {
    	((Stage) ((Node)  event.getSource()).getScene().getWindow()).close();
    }

    @FXML
    void actionAddURLButton(ActionEvent event) {
    	if(!this.unselectedTableView.getSelectionModel().isEmpty()) {
    		LightstreamerJPA i = this.unselectedTableView.getSelectionModel().getSelectedItem();
        	if(!this.selectedTableView.getItems().isEmpty()) {
        		this.unselectedTableView.getItems().add(this.selectedTableView.getItems().remove(0));
        	}
        	this.selectedTableView.getItems().add(i);
        	this.unselectedTableView.getItems().remove(i);
    	}
    }

    

    @FXML
    void actionRemoveURLButton(ActionEvent event) {
    	if(!this.selectedTableView.getSelectionModel().isEmpty()) {
    		LightstreamerJPA i = this.selectedTableView.getSelectionModel().getSelectedItem();
        	this.unselectedTableView.getItems().add(i);
        	this.selectedTableView.getItems().remove(i);
    	}
    }	

}

