/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 08/12/2013
 *
 */
package uoc.tfg.gui.views.webcrawling;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.ResourceBundle;

import javax.naming.NamingException;

import uoc.tfg.gui.views.MessageDialog;
import uoc.tfg.invoke.webcrawling.WebCrawlingSeedInvoke;
import uoc.tfg.model.news.webcrawler.WebCrawlingSeed;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.Node;
import javafx.scene.control.Button;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.TextField;
import javafx.scene.control.cell.PropertyValueFactory;
import javafx.stage.Stage;


/*
 *
 */
public class SelectWebCrawlingSeedViewController implements Initializable {

    @FXML
    private ResourceBundle resources;

    @FXML
    private URL location;

    @FXML
    private Button acceptButton;

    @FXML
    private Button addButton;

    @FXML
    private Button cancelButton;

    @FXML
    private Button removeButton;

    @FXML
    private TableColumn<WebCrawlingSeed, String> selectedColumn;

    @FXML
    private TableView<WebCrawlingSeed> selectedTableView;

    @FXML
    private TableColumn<WebCrawlingSeed, String> unselectedColumn;

    @FXML
    private TableView<WebCrawlingSeed> unselectedTableView;
    
    private WebCrawlingSeed webCrawlingSeed;
    
    private TextField seedTextField;


	/* (non-Javadoc)
	 * @see javafx.fxml.Initializable#initialize(java.net.URL, java.util.ResourceBundle)
	 */
	@Override
	public void initialize(URL arg0, ResourceBundle arg1) {
		// TODO Auto-generated method stub

	}
	
	/**
	 * @param SelectWebCrawlingSeedViewController
	 * @return void
	 * @param webCrawlingSeed
	 * @param seedTextField
	 */
	public void initialize(WebCrawlingSeed webCrawlingSeed, TextField seedTextField) {
		this.unselectedColumn.setCellValueFactory(
				new PropertyValueFactory<WebCrawlingSeed, String>("name"));
		this.selectedColumn.setCellValueFactory(
				new PropertyValueFactory<WebCrawlingSeed, String>("name"));
		
		try {
			this.unselectedTableView.getItems().addAll(
					WebCrawlingSeedInvoke.getAllWebCrawlingSeed());
		} catch (MalformedURLException | NamingException e) {
			new MessageDialog(e);
		}
		
		this.webCrawlingSeed = webCrawlingSeed;
		this.seedTextField = seedTextField;
	}
	
	/**
	 * 
	 * @param iwfr
	 * @param stv
	 */
	public void initialize(WebCrawlingStrategyViewController wcsvc) {
		
		
	}
	
    @FXML
    void accionAcceptButton(ActionEvent event) {
    	
    	for(WebCrawlingSeed wcs: this.selectedTableView.getItems()) {
    		this.webCrawlingSeed.setName(wcs.getName());
    		this.webCrawlingSeed.setDescription(wcs.getDescription());
    		this.webCrawlingSeed.setURLs(wcs.getURLs());
    	}
    	this.seedTextField.setText(this.webCrawlingSeed.getName());
    	((Stage) ((Node)  event.getSource()).getScene().getWindow()).close();
    }
    
    @FXML
    void actionCancelButton(ActionEvent event) {
    	((Stage) ((Node)  event.getSource()).getScene().getWindow()).close();
    }

    @FXML
    void actionAddURLButton(ActionEvent event) {
    	if(!this.unselectedTableView.getSelectionModel().isEmpty()) {
    		WebCrawlingSeed wcs = this.unselectedTableView.getSelectionModel().getSelectedItem();
        	if(!this.selectedTableView.getItems().isEmpty()) {
        		this.unselectedTableView.getItems().add(this.selectedTableView.getItems().remove(0));
        	}
        	this.selectedTableView.getItems().add(wcs);
        	this.unselectedTableView.getItems().remove(wcs);
    	}
    }

    

    @FXML
    void actionRemoveURLButton(ActionEvent event) {
    	if(!this.selectedTableView.getSelectionModel().isEmpty()) {
    		WebCrawlingSeed wcs = this.selectedTableView.getSelectionModel().getSelectedItem();
        	this.unselectedTableView.getItems().add(wcs);
        	this.selectedTableView.getItems().remove(wcs);
    	}
    }	

}

