/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 08/12/2013
 *
 */
package uoc.tfg.gui.views.webcrawling;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.ResourceBundle;

import javax.naming.NamingException;

import uoc.tfg.gui.views.MessageDialog;
import uoc.tfg.invoke.webcrawling.WebCrawlingSeedInvoke;
import uoc.tfg.invoke.webcrawling.WebCrawlingStrategyInvoke;
import uoc.tfg.model.news.WebContentSimpleParser;
import uoc.tfg.model.news.webcrawler.IWebCrawlingStrategy;
import uoc.tfg.model.news.webcrawler.WebCrawlingSeed;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.Node;
import javafx.scene.control.Button;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.TextField;
import javafx.scene.control.cell.PropertyValueFactory;
import javafx.stage.Stage;


/*
 *
 */
public class SelectWebCrawlingStrategyViewController implements Initializable {

    @FXML
    private ResourceBundle resources;

    @FXML
    private URL location;

    @FXML
    private Button acceptButton;

    @FXML
    private Button addButton;

    @FXML
    private Button cancelButton;

    @FXML
    private Button removeButton;

    @FXML
    private TableColumn<IWebCrawlingStrategy, String> selectedColumn;

    @FXML
    private TableView<IWebCrawlingStrategy> selectedTableView;

    @FXML
    private TableColumn<IWebCrawlingStrategy, String> unselectedColumn;

    @FXML
    private TableView<IWebCrawlingStrategy> unselectedTableView;
    
    private IWebCrawlingStrategy webCrawlingStrategy;
    
    private TextField strategyTextField;
    
    private WebCrawlerViewController webCrawlerViewController;


	/* (non-Javadoc)
	 * @see javafx.fxml.Initializable#initialize(java.net.URL, java.util.ResourceBundle)
	 */
	@Override
	public void initialize(URL arg0, ResourceBundle arg1) {
		// TODO Auto-generated method stub

	}
	
	/**
	 * @param wcvc 
	 * @param SelectWebCrawlingSeedViewController
	 * @return void
	 * @param webCrawlingSeed
	 * @param seedTextField
	 */
	public void initialize(WebCrawlerViewController webCrawlerViewController, IWebCrawlingStrategy webCrawlingStrategy, TextField strategyTextField) {
		this.unselectedColumn.setCellValueFactory(
				new PropertyValueFactory<IWebCrawlingStrategy, String>("strategyName"));
		this.selectedColumn.setCellValueFactory(
				new PropertyValueFactory<IWebCrawlingStrategy, String>("strategyName"));
		
		try {
			this.unselectedTableView.getItems().addAll(WebCrawlingStrategyInvoke.getAllWebCrawlingStrategy());
		} catch (NamingException | MalformedURLException e) {
			new MessageDialog(e);
		}
		
		this.webCrawlerViewController = webCrawlerViewController;
		this.webCrawlingStrategy = webCrawlingStrategy;
		this.strategyTextField = strategyTextField;
	}
	
	
	
    @FXML
    void accionAcceptButton(ActionEvent event) {
    	
    	for(IWebCrawlingStrategy wcs: this.selectedTableView.getItems()) {
    		this.webCrawlingStrategy.setStrategyName(wcs.getStrategyName());
    		this.webCrawlingStrategy.setDescription(wcs.getDescription());
    		this.webCrawlingStrategy.setSeed(wcs.getSeed());
    		this.webCrawlingStrategy.setMaxNumUrl(wcs.getMaxNumUrl());
    		this.webCrawlingStrategy.setMaxDepth(wcs.getMaxDepth());
    		this.webCrawlingStrategy.setDelay(wcs.getDelay());
    		this.webCrawlingStrategy.setAlgorithm(wcs.getAlgorithm());
    		this.webCrawlingStrategy.setContentParser(new WebContentSimpleParser());
    	}
    	this.webCrawlerViewController.getStrategyTextField().setText(
    			this.webCrawlingStrategy.getStrategyName());
    	this.webCrawlerViewController.getNameStrategyTextField().setText(
    			this.webCrawlingStrategy.getStrategyName());
    	this.webCrawlerViewController.getDescriptionStrategyTextArea().setText(
    			this.webCrawlingStrategy.getDescription());
    	this.webCrawlerViewController.getMaxURLsTextField().setText(
    			String.valueOf(this.webCrawlingStrategy.getMaxNumUrl()));
    	this.webCrawlerViewController.getDepthTextField().setText(
    			String.valueOf(this.webCrawlingStrategy.getMaxDepth()));
    	this.webCrawlerViewController.getDelayTextField().setText(
    			String.valueOf(this.webCrawlingStrategy.getDelay()));
    	this.webCrawlerViewController.getSeedTextField().setText(
    			String.valueOf(this.webCrawlingStrategy.getSeed().getName()));
    	((Stage) ((Node)  event.getSource()).getScene().getWindow()).close();
    }
    
    @FXML
    void actionCancelButton(ActionEvent event) {
    	((Stage) ((Node)  event.getSource()).getScene().getWindow()).close();
    }

    @FXML
    void actionAddURLButton(ActionEvent event) {
    	if(!this.unselectedTableView.getSelectionModel().isEmpty()) {
    		IWebCrawlingStrategy wcs = this.unselectedTableView.getSelectionModel().getSelectedItem();
        	if(!this.selectedTableView.getItems().isEmpty()) {
        		this.unselectedTableView.getItems().add(this.selectedTableView.getItems().remove(0));
        	}
        	this.selectedTableView.getItems().add(wcs);
        	this.unselectedTableView.getItems().remove(wcs);
    	}
    }

    

    @FXML
    void actionRemoveURLButton(ActionEvent event) {
    	if(!this.selectedTableView.getSelectionModel().isEmpty()) {
    		IWebCrawlingStrategy wcs = this.selectedTableView.getSelectionModel().getSelectedItem();
        	this.unselectedTableView.getItems().add(wcs);
        	this.selectedTableView.getItems().remove(wcs);
    	}
    }	

}

