/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 08/12/2013
 *
 */
package uoc.tfg.gui.views.webcrawling;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.ResourceBundle;

import javax.naming.NamingException;

import uoc.tfg.gui.views.MessageDialog;
import uoc.tfg.invoke.webcrawling.WebCrawlingURLInvoke;
import uoc.tfg.model.news.webcrawler.WebCrawlingURL;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.Node;
import javafx.scene.control.Button;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.cell.PropertyValueFactory;
import javafx.stage.Stage;

/*
 *
 */
public class SelectWebCrawlingURLViewController implements Initializable {

    @FXML
    private ResourceBundle resources;

    @FXML
    private URL location;

    @FXML
    private Button acceptButton;

    @FXML
    private Button addURLButton;

    @FXML
    private Button cancelButton;

    @FXML
    private Button removeURLButton;
    
    @FXML
    private TableColumn<WebCrawlingURL, String> selectedColumn;

    @FXML
    private TableView<WebCrawlingURL> selectedTableView;

    @FXML
    private TableColumn<WebCrawlingURL, String> unselectedColumn;

    @FXML
    private TableView<WebCrawlingURL> unselectedTableView;

    private TableView<WebCrawlingURL> urlTableView;


	/* (non-Javadoc)
	 * @see javafx.fxml.Initializable#initialize(java.net.URL, java.util.ResourceBundle)
	 */
	@Override
	public void initialize(URL arg0, ResourceBundle arg1) {
		// TODO Auto-generated method stub

	}
	
	/**
	 * @param seedUrlsTableView
	 */
	public void initialize(TableView<WebCrawlingURL> seedUrlsTableView) {
		this.unselectedColumn.setCellValueFactory(new PropertyValueFactory<WebCrawlingURL, String>("urlText"));
		this.selectedColumn.setCellValueFactory(new PropertyValueFactory<WebCrawlingURL, String>("urlText"));
		this.urlTableView = seedUrlsTableView;
		try {
			this.unselectedTableView.getItems().addAll(WebCrawlingURLInvoke.getAllWebCrawlingURL());
		} catch (MalformedURLException | NamingException e) {
			new MessageDialog(e);
		}
				
	}
	
    @FXML
    void accionAcceptButton(ActionEvent event) {
    	for(WebCrawlingURL wfc: this.selectedTableView.getItems()) {
    		this.urlTableView.getItems().add(wfc);
    	}
    	((Stage) ((Node)  event.getSource()).getScene().getWindow()).close();
    }
    
    @FXML
    void actionCancelButton(ActionEvent event) {
    	((Stage) ((Node)  event.getSource()).getScene().getWindow()).close();
    }

    @FXML
    void actionAddURLButton(ActionEvent event) {
    	WebCrawlingURL wfc = this.unselectedTableView.getSelectionModel().getSelectedItem();
    	this.selectedTableView.getItems().add(wfc);
    	this.unselectedTableView.getItems().remove(wfc);
    }

    

    @FXML
    void actionRemoveURLButton(ActionEvent event) {
    	WebCrawlingURL wfc = this.selectedTableView.getSelectionModel().getSelectedItem();
    	this.unselectedTableView.getItems().add(wfc);
    	this.selectedTableView.getItems().remove(wfc);
    }

}

