/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 08/01/2014
 *
 */
package uoc.tfg.gui.views.webcrawling;

import java.io.Serializable;

import uoc.tfg.model.news.WebContent;
import javafx.beans.property.SimpleStringProperty;
import javafx.beans.property.StringProperty;


public class WebCrawlingEntryTableModel implements Serializable {
	
	private static final long serialVersionUID = -8834632312460842675L;
	private final WebContent entry;
	private final StringProperty title = new SimpleStringProperty();
    private final StringProperty description = new SimpleStringProperty();
    private final StringProperty date = new SimpleStringProperty();
 
    
    
    public WebCrawlingEntryTableModel(WebContent entry) {
		this.entry = entry;
		this.setTitle(this.entry.getTitle());
		this.setDescription(this.entry.getUrl().toString());
		if(this.entry.getLastModified() != null) this.setDate(this.entry.getLastModified().toString());
	}

	public final String getTitle(){
    	return title.get();
    }
 
    
    public final void setTitle(String value){
    	title.set(value);
    }
 
   
    public StringProperty titleProperty() {
    	return title;
    }
    
    public final String getDescription(){
    	return description.get();
    }
 
    
    public final void setDescription(String value){
    	description.set(value);
    }
 
   
    public StringProperty descriptionProperty() {
    	return description;
    }
    
    public final String getDate(){
    	return date.get();
    }
 
    
    public final void setDate(String value){
    	date.set(value);
    }
 
   
    public StringProperty dateProperty() {
    	return date;
    }

	public WebContent getEntry() {
		return entry;
	}


}
