/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package uoc.tfg.gui.views.webcrawling;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.ResourceBundle;

import javax.naming.NamingException;

import uoc.tfg.exception.GuiException;
import uoc.tfg.gui.views.MessageDialog;
import uoc.tfg.invoke.webcrawling.WebCrawlingURLInvoke;
import uoc.tfg.model.news.webcrawler.WebCrawlingURL;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.Node;
import javafx.scene.control.Button;
import javafx.scene.control.TableView;
import javafx.scene.control.TextArea;
import javafx.scene.control.TextField;
import javafx.stage.Stage;

/**
 * FXML Controller class
 *
 * @author jsanzol
 */
public class WebCrawlingURLViewController implements Initializable {

	@FXML
    private ResourceBundle resources;

    @FXML
    private URL location;

    @FXML
    private Button acceptCrawlingURLButton;

    @FXML
    private Button cancelCrawlingURLButton;

    @FXML
    private TextArea descriptionCrawlingURLTextArea;

    @FXML
    private TextField nameCrawlingURLTextField;

    @FXML
    private TextField urlCrawlingTextField;
    
    private WebCrawlingURL webCrawlingURL;
    
    private TableView<WebCrawlingURL> tableView;
    
    private boolean isNewMode;

    /**
     * Initializes the controller class.
     */
    @Override
    public void initialize(URL url, ResourceBundle rb) {
        
    }    
    
    public void initialize(WebCrawlingURL wcu, TableView<WebCrawlingURL> tv, boolean newMode) {
    	this.isNewMode = newMode;
    	if(this.isNewMode) {
    		this.webCrawlingURL = wcu;
    		this.tableView = tv;
    	} else {
    		this.urlCrawlingTextField.setText(wcu.getUrl().toString());
        	this.nameCrawlingURLTextField.setText(wcu.getName());
        	this.descriptionCrawlingURLTextArea.setText(wcu.getDescription());
    	}	
    }

    @FXML
    private void accionAcceptCrawlingURLButton(ActionEvent event) {
    	String url = this.urlCrawlingTextField.getText();
    	String name = this.nameCrawlingURLTextField.getText();
    	String description = this.descriptionCrawlingURLTextArea.getText();
    	
    	if(url.isEmpty() || name.isEmpty() || description.isEmpty()) {
    		new MessageDialog(new GuiException(GuiException.FORM_NOT_COMPLETE));
    	} else {
    		WebCrawlingURL wcu = null;
			
    		if(this.isNewMode) {
    			try {
    				wcu = new WebCrawlingURL(name, description, url);
        			WebCrawlingURLInvoke.newWebCrawlingURL(wcu);
        		} catch (NamingException | MalformedURLException e) {
        			new MessageDialog(e);
        		}
    			this.webCrawlingURL.setUrl(wcu.getUrl());
        		this.webCrawlingURL.setName(wcu.getName());
        		this.webCrawlingURL.setDescription(wcu.getDescription());
        		this.tableView.getItems().add(this.webCrawlingURL); 
    		} else {
    			try {
    				this.webCrawlingURL.setName(name);
    				this.webCrawlingURL.setDescription(description);
    				WebCrawlingURLInvoke.editWebCrawlingURL(this.webCrawlingURL);
        		} catch (NamingException e) {
        			new MessageDialog(e);
        		}
    		}
    		  		
        	
    		((Stage) ((Node)  event.getSource()).getScene().getWindow()).close();
    	}
    }

    @FXML
    private void actionCancelCrawlingURLButton(ActionEvent event) {
    	((Stage) ((Node)  event.getSource()).getScene().getWindow()).close();
    }
    
}
