/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 08/01/2014
 *
 */
package uoc.tfg.gui.views.webfeed;

import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ResourceBundle;

import javax.naming.NamingException;

import uoc.tfg.exception.DatabaseException;
import uoc.tfg.gui.views.MessageDialog;
import uoc.tfg.invoke.webfeed.WebFeedReaderInvoke;
import uoc.tfg.invoke.webfeed.WebFeedSubscriptionInvoke;
import uoc.tfg.model.news.webfeed.WebFeedSubscription;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.Node;
import javafx.scene.control.Button;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.cell.PropertyValueFactory;
import javafx.stage.Stage;

public class SelectWebFeedSubscriptionViewController implements Initializable {

    @FXML
    private ResourceBundle resources;

    @FXML
    private URL location;

    @FXML
    private Button acceptButton;

    @FXML
    private Button addButton;

    @FXML
    private Button cancelButton;

    @FXML
    private Button removeButton;

    @FXML
    private TableColumn<WebFeedSubscription, String> selectedColumn;

    @FXML
    private TableView<WebFeedSubscription> selectedTableView;

    @FXML
    private TableColumn<WebFeedSubscription, String> unselectedColumn;

    @FXML
    private TableView<WebFeedSubscription> unselectedTableView;
    
    private WebFeedReaderViewController webFeedReaderViewController;

    
	@Override
	public void initialize(URL arg0, ResourceBundle arg1) {
		
	}
	
	/**
	 * 
	 * @param wfrcv
	 */
	public void initialize(WebFeedReaderViewController wfrcv) {
		
		this.unselectedColumn.setCellValueFactory(
				new PropertyValueFactory<WebFeedSubscription, String>("name"));
		this.selectedColumn.setCellValueFactory(
				new PropertyValueFactory<WebFeedSubscription, String>("name"));
		
		try {
			this.unselectedTableView.getItems().addAll(
					WebFeedSubscriptionInvoke.getAllWebFeedSubscriptions());
		} catch (MalformedURLException | NamingException | DatabaseException e) {
			new MessageDialog(e);
		}
		
		this.webFeedReaderViewController = wfrcv;
	}
	
	/**
	 * 
	 * @param event
	 * @throws NamingException
	 */
    @FXML
    void accionAcceptButton(ActionEvent event) throws NamingException {
    	for(WebFeedSubscription wfs: this.selectedTableView.getItems()) {
    		try {
				this.webFeedReaderViewController.getWebFeedSubscriptionsTable().getItems().add(
						new WebFeedReaderInvoke(wfs, this.webFeedReaderViewController.getIndex()));
			} catch (IOException e) {
				new MessageDialog(e);
			}
       	}
    	((Stage) ((Node)  event.getSource()).getScene().getWindow()).close();
    }
    
    /**
     * 
     * @param event
     */
    @FXML
    void actionCancelButton(ActionEvent event) {
    	((Stage) ((Node)  event.getSource()).getScene().getWindow()).close();
    }

    /**
     * 
     * @param event
     */
    @FXML
    void actionAddURLButton(ActionEvent event) {
    	if(!this.unselectedTableView.getSelectionModel().isEmpty()) {
    		WebFeedSubscription wfs = 
    				this.unselectedTableView.getSelectionModel().getSelectedItem();
        	if(!this.selectedTableView.getItems().isEmpty()) {
        		this.unselectedTableView.getItems().add(
        				this.selectedTableView.getItems().remove(0));
        	}
        	this.selectedTableView.getItems().add(wfs);
        	this.unselectedTableView.getItems().remove(wfs);
    	}
    }

    /**
     * 
     * @param event
     */
    @FXML
    void actionRemoveURLButton(ActionEvent event) {
    	if(!this.selectedTableView.getSelectionModel().isEmpty()) {
    		WebFeedSubscription wfu = 
    				this.selectedTableView.getSelectionModel().getSelectedItem();
        	this.unselectedTableView.getItems().add(wfu);
        	this.selectedTableView.getItems().remove(wfu);
    	}
    }

}

