/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 08/01/2014
 *
 */
package uoc.tfg.gui.views.webfeed;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.ResourceBundle;

import javax.naming.NamingException;

import uoc.tfg.exception.DatabaseException;
import uoc.tfg.gui.views.MessageDialog;
import uoc.tfg.invoke.webfeed.WebFeedURLInvoke;
import uoc.tfg.model.news.webfeed.WebFeedURL;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.Node;
import javafx.scene.control.Button;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.cell.PropertyValueFactory;
import javafx.stage.Stage;

public class SelectWebFeedURLViewController implements Initializable {

    @FXML
    private ResourceBundle resources;

    @FXML
    private URL location;

    @FXML
    private Button acceptButton;

    @FXML
    private Button addURLButton;

    @FXML
    private Button cancelButton;

    @FXML
    private Button removeURLButton;
    
    @FXML
    private TableColumn<WebFeedURL, String> selectedColumn;

    @FXML
    private TableView<WebFeedURL> selectedTableView;

    @FXML
    private TableColumn<WebFeedURL, String> unselectedColumn;

    @FXML
    private TableView<WebFeedURL> unselectedTableView;

    private TableView<WebFeedURL> urlTableView;


	@Override
	public void initialize(URL arg0, ResourceBundle arg1) {
		// TODO Auto-generated method stub

	}
	
	/**
	 * 
	 * @param urlTableView
	 */
	public void initialize(TableView<WebFeedURL> urlTableView) {
		this.unselectedColumn.setCellValueFactory(
				new PropertyValueFactory<WebFeedURL, String>("urlText"));
		this.selectedColumn.setCellValueFactory(
				new PropertyValueFactory<WebFeedURL, String>("urlText"));
		this.urlTableView = urlTableView;
		try {
			this.unselectedTableView.getItems().addAll(WebFeedURLInvoke.getAllWebFeedURLs());
		} catch (MalformedURLException | NamingException | DatabaseException e) {
			new MessageDialog(e);
		}
				
	}
	
	/**
	 * 
	 * @param event
	 */
    @FXML
    void accionAcceptButton(ActionEvent event) {
    	for(WebFeedURL wfu: this.selectedTableView.getItems()) {
    		this.urlTableView.getItems().add(wfu);
    	}
    	((Stage) ((Node)  event.getSource()).getScene().getWindow()).close();
    }
    
    /**
     * 
     * @param event
     */
    @FXML
    void actionCancelButton(ActionEvent event) {
    	((Stage) ((Node)  event.getSource()).getScene().getWindow()).close();
    }

    /**
     * 
     * @param event
     */
    @FXML
    void actionAddURLButton(ActionEvent event) {
    	WebFeedURL wfu = this.unselectedTableView.getSelectionModel().getSelectedItem();
    	this.selectedTableView.getItems().add(wfu);
    	this.unselectedTableView.getItems().remove(wfu);
    }

    

    @FXML
    void actionRemoveURLButton(ActionEvent event) {
    	WebFeedURL wfu = this.selectedTableView.getSelectionModel().getSelectedItem();
    	this.unselectedTableView.getItems().add(wfu);
    	this.selectedTableView.getItems().remove(wfu);
    }

}

