/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 08/01/2014
 *
 */
package uoc.tfg.gui.views.webfeed;

import java.io.Serializable;

import com.sun.syndication.feed.synd.SyndEntry;

import javafx.beans.property.SimpleStringProperty;
import javafx.beans.property.StringProperty;


public class WebFeedEntryTableModel implements Serializable {
	
	private static final long serialVersionUID = -8834632312460842675L;
	private final SyndEntry entry;
	private final StringProperty title = new SimpleStringProperty();
    private final StringProperty description = new SimpleStringProperty();
    private final StringProperty date = new SimpleStringProperty();
 
    
    
    public WebFeedEntryTableModel(SyndEntry entry) {
		this.entry = entry;
		this.setTitle(this.entry.getTitle());
		this.setDescription(this.entry.getDescription().getValue());
		this.setDate(this.entry.getPublishedDate().toString());
	}


	public final String getTitle(){
    	return title.get();
    }
 
    
    public final void setTitle(String value){
    	title.set(value);
    }
 
   
    public StringProperty titleProperty() {
    	return title;
    }
    
    public final String getDescription(){
    	return description.get();
    }
 
    
    public final void setDescription(String value){
    	description.set(value);
    }
 
   
    public StringProperty descriptionProperty() {
    	return description;
    }
    
    public final String getDate(){
    	return date.get();
    }
 
    
    public final void setDate(String value){
    	date.set(value);
    }
 
   
    public StringProperty dateProperty() {
    	return date;
    }

	public SyndEntry getEntry() {
		return entry;
	}


}
