package uoc.tfg.invoke.document;

import java.io.IOException;
import java.util.List;

import org.apache.lucene.document.Document;
import org.apache.lucene.queryparser.classic.ParseException;

import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import uoc.tfg.gui.views.document.DocumentTableModel;
import uoc.tfg.manager.document.IIndexExplorerManager;
import uoc.tfg.manager.document.IndexExplorerManager;
import uoc.tfg.model.document.Index;

public class IndexExplorerInvoke {
	
	private IIndexExplorerManager manager;
	private ObservableList<DocumentTableModel> documents = 
			FXCollections.observableArrayList();
	private ObservableList<DocumentTableModel> searchDocuments = 
			FXCollections.observableArrayList();

	public IndexExplorerInvoke(Index index) throws IOException {
		this.manager = new IndexExplorerManager(index);
	}
	
	public List<Document> getAllDocuments() throws IOException {
		
		return manager.getAllDocuments();
	}
	
	public int getNumDocuments() throws IOException {
		return manager.getNumDocuments();
	}
	
	public ObservableList<DocumentTableModel> getDocuments() throws IOException {
		
		for(Document d: this.getAllDocuments()) {
			this.documents.add(new DocumentTableModel(d));
		}
		return documents;
	}

	public void setDocuments(ObservableList<DocumentTableModel> documents) {
		this.documents = documents;
	}
	
	public ObservableList<DocumentTableModel> getSearchDocuments() {
	
		return this.searchDocuments;
	}

	public void setSearchDocuments(ObservableList<DocumentTableModel> searchDocuments) {
		this.searchDocuments = searchDocuments;
	}


	public void searchDocuments(String[] fields, String[] queries, String[] logicals) throws ParseException, IOException {
		
		this.searchDocuments.clear();
		for(Document d: this.manager.searchDocuments(fields, queries, logicals)) {
			this.searchDocuments.add(new DocumentTableModel(d));
		}
	}
	
}
