/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 07/12/2013
 *
 */
package uoc.tfg.invoke.marketdata;

import java.io.Serializable;
import java.util.List;
import java.util.Observable;
import java.util.Observer;

import javafx.collections.FXCollections;
import javafx.collections.ObservableList;

import javax.naming.Context;
import javax.naming.NamingException;

import uoc.tfg.exception.WebFeedException;
import uoc.tfg.gui.views.marketdata.MarketDataTableModel;
import uoc.tfg.gui.views.webfeed.WebFeedEntryTableModel;
import uoc.tfg.gui.views.webfeed.WebFeedSubscriptionTableModel;
import uoc.tfg.jpa.marketdata.LightstreamerJPA;
import uoc.tfg.manager.marketdata.IMarketDataLSManager;
import uoc.tfg.manager.marketdata.MarketDataLSManager;
import uoc.tfg.manager.webfeed.IWebFeedReaderManager;
import uoc.tfg.manager.webfeed.WebFeedReaderManager;
import uoc.tfg.model.document.Index;
import uoc.tfg.model.marketdata.lightstreamer.AdapterInfoLS;
import uoc.tfg.model.marketdata.lightstreamer.DataFeederLS;

/*
 *
 */
public class MarketdataLSInvoke implements Observer, Serializable {
		
	/**
	 * 
	 */
	private static final long serialVersionUID = -5668262028136922494L;
	private IMarketDataLSManager manager;
	private ObservableList<MarketDataTableModel> entries = 
			FXCollections.observableArrayList();
	
	
	public MarketdataLSInvoke() {
		this.manager = new MarketDataLSManager();
		this.manager.setObserver(this);
		for(String key : AdapterInfoLS.itemsReferences.stringPropertyNames()) {
			this.entries.add(new MarketDataTableModel(
					AdapterInfoLS.itemsReferences.getProperty(key)));
		}
		
	}
	
	public void startMarketDataStreaming() throws Exception {
		
		this.manager.startMarketDataStreaming();;
	}
	
	/**
	 * @throws Exception 
	 * 
	 */
	public void pauseMarketDataStreaming() throws Exception {
		this.manager.pauseMarketDataStreaming();
	}

	/**
	 * @throws Exception 
	 * 
	 */
	public void resumeMarketDataStreaming() throws Exception {
		this.manager.resumeMarketDataStreaming();
	}

	/**
	 * @throws Exception 
	 * 
	 */
	public void stopMarketDataStreaming() throws Exception {
		this.manager.stopMarketDataStreaming();
	}
	
	public ObservableList<MarketDataTableModel> getEntries() {
		return entries;
	}

	public void setEntries(ObservableList<MarketDataTableModel> entries) {
		this.entries = entries;
	}

	@Override
	public void update(Observable o, Object arg1) {
		
		MarketDataTableModel entry = 
				this.entries.get(this.manager.getLastUpdatePosition());
		entry.setData(this.manager.getLastUpdate());
	}

	public List<LightstreamerJPA> getAllServer() {
		
		return this.manager.getAllServer();
	}
	
	
}
