/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 12/12/2013
 *
 */
package uoc.tfg.invoke.webcrawling;

import java.net.MalformedURLException;
import java.util.List;

import javax.naming.NamingException;

import uoc.tfg.exception.DatabaseException;
import uoc.tfg.manager.webcrawling.IWebCrawlingSeedManager;
import uoc.tfg.manager.webcrawling.WebCrawlingSeedManager;
import uoc.tfg.model.news.webcrawler.WebCrawlingSeed;

/*
 *
 */
public class WebCrawlingSeedInvoke {
	
	private static IWebCrawlingSeedManager manager = (IWebCrawlingSeedManager) new WebCrawlingSeedManager();
	
	public static void newWebCrawlingURL(WebCrawlingSeed wcs) throws NamingException {
		
		manager.newWebCrawlingSeed(wcs);
	}

	public static void editWebCrawlingURL(WebCrawlingSeed wcs) throws NamingException {

		manager.editWebCrawlingSeed(wcs);
	}
	
	public static void deleteWebCrawlingSeed(String url) throws DatabaseException, NamingException {

		manager.deleteWebCrawlingSeed(url);
	}
	
	public static WebCrawlingSeed getWebCrawlingURL(String url) throws MalformedURLException, DatabaseException, NamingException {
		
		return manager.getWebCrawlingSeed(url);
	}
	
	public static List<WebCrawlingSeed> getAllWebCrawlingSeed() throws MalformedURLException, NamingException {
		
		return manager.getAllWebCrawlingSeed();
	}
	
	
	

}
