/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 12/12/2013
 *
 */
package uoc.tfg.invoke.webcrawling;

import java.net.MalformedURLException;
import java.util.List;

import javax.naming.NamingException;

import uoc.tfg.exception.DatabaseException;
import uoc.tfg.manager.webcrawling.IWebCrawlingStrategyManager;
import uoc.tfg.manager.webcrawling.WebCrawlingStrategyManager;
import uoc.tfg.model.news.webcrawler.IWebCrawlingStrategy;

/*
 *
 */
public class WebCrawlingStrategyInvoke {
	
	private static IWebCrawlingStrategyManager manager = new WebCrawlingStrategyManager();
	
	public static void newWebCrawlingURL(IWebCrawlingStrategy wcs) {
		
		manager.newWebCrawlingStrategy(wcs);
	}

	public static void editWebCrawlingStrategy(IWebCrawlingStrategy wcs) throws NamingException {

		manager.editWebCrawlingStrategy(wcs);
	}
	
	public static void deleteWebCrawlingStrategy(String name) throws DatabaseException, NamingException {

		manager.deleteWebCrawlingStrategy(name);
	}
	
	public static IWebCrawlingStrategy getWebCrawlingStrategy(String name) throws NamingException, DatabaseException, MalformedURLException {
		
		return manager.getWebCrawlingStrategy(name);
	}
	
	public static List<IWebCrawlingStrategy> getAllWebCrawlingStrategy() throws NamingException, MalformedURLException {
		
		return manager.getAllWebCrawlingStrategy();
	}

}
