/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 08/01/2014
 *
 */
package uoc.tfg.invoke.webfeed;

import java.net.MalformedURLException;
import java.util.List;

import javax.naming.NamingException;

import uoc.tfg.exception.DatabaseException;
import uoc.tfg.manager.webfeed.IWebFeedSubscriptionManager;
import uoc.tfg.manager.webfeed.WebFeedSubscriptionManager;
import uoc.tfg.model.news.webfeed.WebFeedSubscription;


public class WebFeedSubscriptionInvoke {
	
	/**
	 * 
	 * @param wfs
	 * @throws NamingException
	 */
	public static void newWebFeedSubscription(WebFeedSubscription wfs) throws NamingException {
		
		IWebFeedSubscriptionManager manager = new WebFeedSubscriptionManager();
		manager.newWebFeedSubscription(wfs);
		
	}

	/**
	 * 
	 * @param wfs
	 * @throws NamingException
	 */
	public static void editWebFeedSubscription(WebFeedSubscription wfs) throws NamingException {

		IWebFeedSubscriptionManager manager = new WebFeedSubscriptionManager();
		manager.editWebFeedSubscription(wfs);
		
	}
	
	/**
	 * 
	 * @param s
	 * @throws NamingException
	 * @throws DatabaseException
	 */
	public static void deleteWebFeedSubscription(String s) throws NamingException, DatabaseException {

		IWebFeedSubscriptionManager manager = new WebFeedSubscriptionManager();
		manager.deleteWebFeedSubscription(s);
	}
	
	/**
	 * 
	 * @param s
	 * @return
	 * @throws NamingException
	 * @throws MalformedURLException
	 * @throws DatabaseException
	 */
	public static WebFeedSubscription getWebFeedSubscription(String s) throws NamingException, MalformedURLException, DatabaseException {
		
		IWebFeedSubscriptionManager manager = new WebFeedSubscriptionManager();
		return manager.getWebFeedSubscription(s);
		
	}
	
	/**
	 * 
	 * @return
	 * @throws NamingException
	 * @throws MalformedURLException
	 * @throws DatabaseException
	 */
	public static List<WebFeedSubscription> getAllWebFeedSubscriptions() throws NamingException, MalformedURLException, DatabaseException {
		
		IWebFeedSubscriptionManager manager = new WebFeedSubscriptionManager();
		return manager.getAllWebFeedSubscription();
	}
	
}
