/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 08/01/2014
 *
 */
package uoc.tfg.invoke.webfeed;

import java.net.MalformedURLException;
import java.util.List;

import javax.naming.NamingException;

import uoc.tfg.exception.DatabaseException;
import uoc.tfg.manager.webfeed.IWebFeedURLManager;
import uoc.tfg.manager.webfeed.WebFeedURLManager;
import uoc.tfg.model.news.webfeed.WebFeedURL;


public class WebFeedURLInvoke {
	
	private static IWebFeedURLManager manager = new WebFeedURLManager();
	
	/**
	 * 
	 * @param wfu
	 * @throws NamingException
	 */
	public static void newWebFeedURL(WebFeedURL wfu) throws NamingException  {
		
		manager.newWebFeedURL(wfu);
		
	}

	/**
	 * 
	 * @param wfu
	 * @throws NamingException
	 */
	public static void editWebFeedURL(WebFeedURL wfu) throws NamingException {

		manager.editWebFeedURL(wfu);
	}
	
	/**
	 * 
	 * @param url
	 * @throws NamingException
	 * @throws DatabaseException
	 */
	public static void deleteWebFeedURL(String url) throws NamingException, DatabaseException {

		manager.deleteWebFeedURL(url);
	}
	
	/**
	 * 
	 * @param url
	 * @return
	 * @throws NamingException
	 * @throws MalformedURLException
	 * @throws DatabaseException
	 */
	public static WebFeedURL getWebFeedURL(String url) 
			throws NamingException, MalformedURLException, DatabaseException {
		
		return manager.getWebFeedURL(url);
	}
	
	/**
	 * 
	 * @return
	 * @throws NamingException
	 * @throws MalformedURLException
	 * @throws DatabaseException
	 */
	public static List<WebFeedURL> getAllWebFeedURLs() 
			throws NamingException, MalformedURLException, DatabaseException {
		
		return manager.getAllWebFeedURL();
	}
	
	
	
}
