package uoc.tfg.jpa.analysis;

import java.io.Serializable;

import javax.persistence.*;

import uoc.tfg.model.textanalysis.classification.Category;


/**
 * The persistent class for the category database table.
 * 
 */
@Entity
@Table(name="category")
@NamedQuery(name="CategoryJPA.findAll", query="SELECT c FROM CategoryJPA c")
public class CategoryJPA implements Serializable {
	private static final long serialVersionUID = 1L;

	@EmbeddedId
	private CategoryJPAPK id;

	public CategoryJPA() {
	}

	public CategoryJPA(Category c) {
		
		this.id = new CategoryJPAPK(c.getName(), c.getValue());
	}
	
	public Category getCategory() {
		
		return new Category(this.id.getCategory_name(), this.id.getCategory_value());
	}

	public CategoryJPAPK getId() {
		return this.id;
	}

	public void setId(CategoryJPAPK id) {
		this.id = id;
	}

}