package uoc.tfg.jpa.analysis;

import java.io.Serializable;

import javax.persistence.*;

/**
 * The primary key class for the category database table.
 * 
 */
@Embeddable
public class CategoryJPAPK implements Serializable {
	//default serial version id, required for serializable classes.
	private static final long serialVersionUID = 1L;

	private Integer category_value;

	private String category_name;

	public CategoryJPAPK() {
	}
	public CategoryJPAPK(String name, int value) {

		this.category_name = name;
		this.category_value = Integer.valueOf(value);
	}
	
	public Integer getCategory_value() {
		return this.category_value;
	}
	public void setCategory_value(Integer category_value) {
		this.category_value = category_value;
	}
	public String getCategory_name() {
		return this.category_name;
	}
	public void setCategory_name(String category_name) {
		this.category_name = category_name;
	}

	public boolean equals(Object other) {
		if (this == other) {
			return true;
		}
		if (!(other instanceof CategoryJPAPK)) {
			return false;
		}
		CategoryJPAPK castOther = (CategoryJPAPK)other;
		return 
			this.category_value.equals(castOther.category_value)
			&& this.category_name.equals(castOther.category_name);
	}

	public int hashCode() {
		final int prime = 31;
		int hash = 17;
		hash = hash * prime + this.category_value.hashCode();
		hash = hash * prime + this.category_name.hashCode();
		
		return hash;
	}
}