package uoc.tfg.jpa.analysis;

import java.io.Serializable;

import javax.persistence.*;

import uoc.tfg.model.textanalysis.IToken;
import uoc.tfg.model.textanalysis.Token;


/**
 * The persistent class for the token database table.
 * 
 */
@Entity
@Table(name="token")
@NamedQuery(name="TokenJPA.findAll", query="SELECT t FROM TokenJPA t")
public class TokenJPA implements Serializable {
	private static final long serialVersionUID = 1L;

	@EmbeddedId
	private TokenJPAPK id;

	//bi-directional many-to-one association to TokenCollectionJPA
	@ManyToOne
	@JoinColumn(name="collection")
	private TokenCollectionJPA tokenCollection;

	public TokenJPA() {
	}
	
	public TokenJPA(IToken token, TokenCollectionJPA tcJPA) {
		this.id = new TokenJPAPK(token.getValue(), token.getCollection().getName());
		this.tokenCollection = tcJPA;
	}

	public TokenJPAPK getId() {
		return this.id;
	}

	public void setId(TokenJPAPK id) {
		this.id = id;
	}

	public TokenCollectionJPA getTokenCollection() {
		return this.tokenCollection;
	}

	public void setTokenCollection(TokenCollectionJPA tokenCollection) {
		this.tokenCollection = tokenCollection;
	}

}