package uoc.tfg.jpa.analysis;

import java.io.Serializable;

import javax.persistence.*;

/**
 * The primary key class for the token database table.
 * 
 */
@Embeddable
public class TokenJPAPK implements Serializable {
	//default serial version id, required for serializable classes.
	private static final long serialVersionUID = 1L;

	private String token;

	@Column(insertable=false, updatable=false)
	private String collection;

	public TokenJPAPK() {
	}
	
	public TokenJPAPK(String value, String collection) {

		this.token = value;
		this.collection = collection;
	}
	public String getToken() {
		return this.token;
	}
	public void setToken(String token) {
		this.token = token;
	}
	public String getCollection() {
		return this.collection;
	}
	public void setCollection(String collection) {
		this.collection = collection;
	}

	public boolean equals(Object other) {
		if (this == other) {
			return true;
		}
		if (!(other instanceof TokenJPAPK)) {
			return false;
		}
		TokenJPAPK castOther = (TokenJPAPK)other;
		return 
			this.token.equals(castOther.token)
			&& this.collection.equals(castOther.collection);
	}

	public int hashCode() {
		final int prime = 31;
		int hash = 17;
		hash = hash * prime + this.token.hashCode();
		hash = hash * prime + this.collection.hashCode();
		
		return hash;
	}
}