package uoc.tfg.jpa.document;

import java.io.Serializable;
import javax.persistence.*;

import uoc.tfg.model.document.Index;


/**
 * The persistent class for the index database table.
 * 
 */
@Entity
@Table(name="index")
@NamedQuery(name="IndexJPA.findAll", query="SELECT i FROM IndexJPA i")
public class IndexJPA implements Serializable {
	private static final long serialVersionUID = 1L;

	@Id
	private String path;

	private String description;

	private String name;

	public IndexJPA() {
		
	}
	
	public IndexJPA(Index i) {
		this.name = i.getName();
		this.description = i.getDescription();
		this.path = i.getPath().getAbsolutePath();
	}
	
	public Index getIndex() {
		Index i = new Index(
				this.getName(),
				this.getDescription(),
				this.getPath());
		return i;
	}

	public String getPath() {
		return this.path;
	}

	public void setPath(String path) {
		this.path = path;
	}

	public String getDescription() {
		return this.description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public String getName() {
		return this.name;
	}

	public void setName(String name) {
		this.name = name;
	}

}