package uoc.tfg.jpa.marketdata;

import java.io.Serializable;
import javax.persistence.*;

/**
 * The primary key class for the tick_marketdata database table.
 * 
 */
@Embeddable
public class UnitaryTickDataPK implements Serializable {
	//default serial version id, required for serializable classes.
	private static final long serialVersionUID = 1L;

	private String reference;

	private Long volume;

	public UnitaryTickDataPK() {
	}
	public String getReference() {
		return this.reference;
	}
	public void setReference(String reference) {
		this.reference = reference;
	}
	public Long getVolume() {
		return this.volume;
	}
	public void setVolume(Long volume) {
		this.volume = volume;
	}

	public boolean equals(Object other) {
		if (this == other) {
			return true;
		}
		if (!(other instanceof UnitaryTickDataPK)) {
			return false;
		}
		UnitaryTickDataPK castOther = (UnitaryTickDataPK)other;
		return 
			this.reference.equals(castOther.reference)
			&& this.volume.equals(castOther.volume);
	}

	public int hashCode() {
		final int prime = 31;
		int hash = 17;
		hash = hash * prime + this.reference.hashCode();
		hash = hash * prime + this.volume.hashCode();
		
		return hash;
	}
}