package uoc.tfg.jpa.news.webcrawling;

import java.io.Serializable;
import java.net.MalformedURLException;

import javax.persistence.*;

import uoc.tfg.model.news.webcrawler.WebCrawlingURL;


/**
 * The persistent class for the crawling_url database table.
 * 
 */
@Entity
@Table(name="crawling_url")
@NamedQuery(name="WebCrawlingURLJPA.findAll", query="SELECT c FROM WebCrawlingURLJPA c")
public class WebCrawlingURLJPA implements Serializable {
	
	private static final long serialVersionUID = 1058862810939677431L;

	@Id
	private String url;

	private String description;

	@Column(name="url_name")
	private String urlName;

	
	public WebCrawlingURLJPA() {
		super();
		// TODO Auto-generated constructor stub
	}

	public WebCrawlingURLJPA(WebCrawlingURL wcu) {
		this.setUrlName(wcu.getName());
		this.setDescription(wcu.getDescription());
		this.setUrl(wcu.getUrl().toString());
	}
	
	public WebCrawlingURL getWebCrawlingURL() throws MalformedURLException {
		return new WebCrawlingURL(this.urlName, this.description, this.url);
	}

	public String getUrl() {
		return this.url;
	}

	public void setUrl(String url) {
		this.url = url;
	}

	public String getDescription() {
		return this.description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public String getUrlName() {
		return this.urlName;
	}

	public void setUrlName(String urlName) {
		this.urlName = urlName;
	}

}