/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 08/01/2014
 *
 */
package uoc.tfg.jpa.news.webfeed;

import java.io.Serializable;
import java.net.MalformedURLException;

import javax.persistence.*;

import uoc.tfg.model.news.webfeed.WebFeedFormat;
import uoc.tfg.model.news.webfeed.WebFeedURL;

import java.util.Date;


@Entity
@Table(name="feed_url")
@NamedQuery(name="WebFeedURLJPA.findAll", query="SELECT w FROM WebFeedURLJPA w")
public class WebFeedURLJPA implements Serializable {
	
	private static final long serialVersionUID = -5892204200231180513L;

	@Id
	private String url;

	@Temporal(TemporalType.TIMESTAMP)
	private Date lastpoll;

	@Column(name="url_description")
	private String urlDescription;

	@Column(name="url_format")
	private String urlFormat;

	@Column(name="url_name")
	private String urlName;

	/**
	 * 
	 * Constructor
	 *
	 * WebFeedURLJPA
	 */
	public WebFeedURLJPA() {
		super();
	}
	
	/**
	 * 
	 * Constructor
	 *
	 * WebFeedURLJPA
	 */
	public WebFeedURLJPA(WebFeedURL wfu) {
		this(wfu.getUrl().toString(), wfu.getName(), wfu.getDescription(), 
				wfu.getWebFeedformat().toString(), wfu.getLastPoll());
	}

	/**
	 * 
	 * Constructor
	 *
	 * WebFeedURLJPA
	 */
	public WebFeedURLJPA(String url, String name, String description, 
			String webFeedformat, Date lastPoll) {
		this.url = url;
		this.urlName = name;
		this.urlDescription = description;
		this.urlFormat = webFeedformat;
		this.lastpoll = lastPoll;
	}
	
	/**
	 * 
	 * @param WebFeedURLJPA
	 * @return WebFeedURL
	 */
	public WebFeedURL getWebFeedURL() throws MalformedURLException {
		WebFeedURL wfu = new WebFeedURL(
				this.getUrl(),
				this.getUrlName(),
				this.getUrlDescription(),
				WebFeedFormat.getValueOf(this.urlFormat),
				this.getLastpoll());
		return wfu;
	}

	/**
	 * 
	 * @param WebFeedURLJPA
	 * @return String
	 */
	public String getUrl() {
		return this.url;
	}

	/**
	 * 
	 * @param WebFeedURLJPA
	 * @return void
	 */
	public void setUrl(String url) {
		this.url = url;
	}

	/**
	 * 
	 * @param WebFeedURLJPA
	 * @return Date
	 */
	public Date getLastpoll() {
		return this.lastpoll;
	}

	/**
	 * 
	 * @param WebFeedURLJPA
	 * @return void
	 */
	public void setLastpoll(Date lastpoll) {
		this.lastpoll = lastpoll;
	}
	
	/**
	 * 
	 * @param WebFeedURLJPA
	 * @return String
	 */
	public String getUrlDescription() {
		return this.urlDescription;
	}

	/**
	 * 
	 * @param WebFeedURLJPA
	 * @return void
	 */
	public void setUrlDescription(String urlDescription) {
		this.urlDescription = urlDescription;
	}

	/**
	 * 
	 * @param WebFeedURLJPA
	 * @return String
	 */
	public String getUrlFormat() {
		return this.urlFormat;
	}

	/**
	 * 
	 * @param WebFeedURLJPA
	 * @return void
	 */
	public void setUrlFormat(String urlFormat) {
		this.urlFormat = urlFormat;
	}

	/**
	 * 
	 * @param WebFeedURLJPA
	 * @return String
	 */
	public String getUrlName() {
		return this.urlName;
	}

	/**
	 * 
	 * @param WebFeedURLJPA
	 * @return void
	 */
	public void setUrlName(String urlName) {
		this.urlName = urlName;
	}

}