package uoc.tfg.manager.analysis;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.Query;

import uoc.tfg.exception.DatabaseException;
import uoc.tfg.jpa.DatabaseManager;
import uoc.tfg.jpa.analysis.CategorySetJPA;
import uoc.tfg.model.textanalysis.classification.CategorySet;

public class CategorySetManager implements ICategorySetManager {

	@Override
	public void newCategorySet(CategorySet cs) {
		
		DatabaseManager.persist(new CategorySetJPA(cs));
	}

	@Override
	public void editCategorySet(CategorySet cs) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void deleteCategorySet(String name) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public CategorySet getCategorySet(String name) throws DatabaseException {
		
		EntityManager entitymanager = 
				DatabaseManager.getFactory().createEntityManager();
		CategorySetJPA csJPA = entitymanager.find(CategorySetJPA.class, name);
		if(csJPA == null) {
			throw new DatabaseException(DatabaseException.ENTRY_NOT_FOUND);
		} else {
			return csJPA.getCategorySet();
		}
	}

	@Override
	public List<CategorySet> getAllCategorySets() {
		
		EntityManager entitymanager = 
				DatabaseManager.getFactory().createEntityManager();
		List<CategorySet> css = new ArrayList<CategorySet>();
		Query query = entitymanager.createQuery("SELECT e FROM CategorySetJPA e");
		List<CategorySetJPA> csJPAs = (List<CategorySetJPA>) query.getResultList();
		for(CategorySetJPA csJPA: csJPAs) {
			css.add(csJPA.getCategorySet());
		}
		return css;
	}

}
