package uoc.tfg.manager.analysis;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.Query;

import uoc.tfg.exception.DatabaseException;
import uoc.tfg.jpa.DatabaseManager;
import uoc.tfg.jpa.analysis.TokenCollectionJPA;
import uoc.tfg.model.textanalysis.ITokenCollection;

public class TokenCollectionManager implements ITokenCollectionManager {

	@Override
	public void newTokenCollection(ITokenCollection tc) {

		DatabaseManager.persist(new TokenCollectionJPA(tc));
	}

	@Override
	public void editTokenCollection(ITokenCollection tc) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void deleteTokenCollection(String name) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public ITokenCollection getTokenCollection(String name) throws DatabaseException {
		
		EntityManager entitymanager = 
				DatabaseManager.getFactory().createEntityManager();
		TokenCollectionJPA tcJPA = entitymanager.find(TokenCollectionJPA.class, name);
		if(tcJPA == null) {
			throw new DatabaseException(DatabaseException.ENTRY_NOT_FOUND);
		} else {
			return tcJPA.getTokenCollection();
		}
	}

	@Override
	public List<ITokenCollection> getAllTokenCollections() {

		EntityManager entitymanager = 
				DatabaseManager.getFactory().createEntityManager();
		List<ITokenCollection> tcs = new ArrayList<ITokenCollection>();
		Query query = entitymanager.createQuery("SELECT e FROM TokenCollectionJPA e");
		List<TokenCollectionJPA> tcJPAs = (List<TokenCollectionJPA>) query.getResultList();
		for(TokenCollectionJPA tcJPA: tcJPAs) {
			tcs.add(tcJPA.getTokenCollection());
		}
		return tcs;
	}

}
