package uoc.tfg.manager.document;

import java.io.IOException;
import java.util.List;

import org.apache.lucene.document.Document;
import org.apache.lucene.queryparser.classic.ParseException;

import uoc.tfg.model.document.Index;
import uoc.tfg.model.document.IIndexHandler;
import uoc.tfg.model.document.IndexHandler;


public class IndexExplorerManager implements IIndexExplorerManager {
	
	IIndexHandler indexManager;

	public IndexExplorerManager(Index i) throws IOException {
		indexManager = new IndexHandler(i.getPath());
	}

	@Override
	public List<Document> getAllDocuments() throws IOException {
		
		return this.indexManager.getAllDocuments();
	}

	@Override
	public int getNumDocuments() throws IOException {
		
		return this.indexManager.getNumDocuments();
	}

	@Override
	public List<Document> searchDocuments(
			String[] fields, String[] queries, String[] logicals) 
					throws ParseException, IOException {
		
		return this.indexManager.searchIndex(fields, queries, logicals);
	}
	
	

}
