/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 23/12/2013
 *
 */
package uoc.tfg.manager.webcrawling;

import java.net.MalformedURLException;
import java.util.List;

import uoc.tfg.exception.DatabaseException;
import uoc.tfg.model.news.webcrawler.IWebCrawlingStrategy;

/*
 *
 */
public interface IWebCrawlingStrategyManager {

	/**
	 * @param wcs
	 */
	public void newWebCrawlingStrategy(IWebCrawlingStrategy wcs);

	/**
	 * @param wcs
	 */
	public void editWebCrawlingStrategy(IWebCrawlingStrategy wcs);

	/**
	 * @param url
	 * @throws DatabaseException 
	 */
	public void deleteWebCrawlingStrategy(String name) throws DatabaseException;

	/**
	 * @param url
	 * @return
	 * @throws DatabaseException 
	 * @throws MalformedURLException 
	 */
	public IWebCrawlingStrategy getWebCrawlingStrategy(String name) throws DatabaseException, MalformedURLException;

	/**
	 * @return
	 * @throws MalformedURLException 
	 */
	public List<IWebCrawlingStrategy> getAllWebCrawlingStrategy() throws MalformedURLException;

	/**
	 * @param IWebCrawlingStrategyManager
	 * @return void
	 * @param wcs
	 */
	public void refreshWebCrawlingStrategy(IWebCrawlingStrategy wcs);


}
