/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 08/01/2014
 *
 */
package uoc.tfg.manager.webfeed;

import java.io.IOException;
import java.util.Observer;
import java.util.Queue;

import com.sun.syndication.feed.synd.SyndEntry;

import uoc.tfg.exception.WebFeedException;
import uoc.tfg.model.document.Index;


public interface IWebFeedReaderManager {

	/**
	 * 
	 * @param IWebFeedReaderManager
	 * @return void
	 * @throws WebFeedException
	 */
	public void startWebFeedReader() throws WebFeedException;

	/**
	 * 
	 * @param IWebFeedReaderManager
	 * @return void
	 */
	public void pausetWebFeedReader();

	/**
	 * 
	 * @param IWebFeedReaderManager
	 * @return void
	 */
	public void resumeWebFeedReader();

	/**
	 * 
	 * @param IWebFeedReaderManager
	 * @return void
	 */
	public void stopWebFeedReader();

	/**
	 * 
	 * @param IWebFeedReaderManager
	 * @return void
	 * @param o
	 */
	public void addObserver(Observer o);

	/**
	 * 
	 * @param IWebFeedReaderManager
	 * @return String
	 * @return
	 */
	public String getName();

	/**
	 * @return
	 */
	public String getStatus();

	/**
	 * @return
	 */
	public Queue<SyndEntry> getLastEntries();

	public void setIndex(Index i) throws IOException;

}
