/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 23/12/2013
 *
 */
package uoc.tfg.manager.webfeed;

import java.net.MalformedURLException;
import java.util.List;

import uoc.tfg.exception.DatabaseException;
import uoc.tfg.model.news.webfeed.WebFeedURL;

/*
 *
 */
public interface IWebFeedURLManager {

	/**
	 * @param wfu
	 */
	public void newWebFeedURL(WebFeedURL wfu);

	/**
	 * @param wfu
	 */
	public void editWebFeedURL(WebFeedURL wfu);

	/**
	 * @param url
	 * @throws DatabaseException 
	 */
	public void deleteWebFeedURL(String url) throws DatabaseException;

	/**
	 * @param url
	 * @return
	 * @throws MalformedURLException 
	 * @throws DatabaseException 
	 */
	public WebFeedURL getWebFeedURL(String url) throws DatabaseException, MalformedURLException;

	/**
	 * @return
	 * @throws MalformedURLException 
	 */
	public List<WebFeedURL> getAllWebFeedURL() throws MalformedURLException;

	/**
	 * @param wfu
	 */
	public void refreshWebFeedURL(WebFeedURL wfu);

	

}
