/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 23/12/2013
 *
 */
package uoc.tfg.manager.webfeed;

import java.net.MalformedURLException;
import java.util.ArrayList;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.Query;

import uoc.tfg.exception.DatabaseException;
import uoc.tfg.jpa.DatabaseManager;
import uoc.tfg.jpa.news.webfeed.WebFeedSubscriptionJPA;
import uoc.tfg.model.news.webfeed.WebFeedSubscription;

/*
 *
 */
public class WebFeedSubscriptionManager implements IWebFeedSubscriptionManager {

	@Override
    public void newWebFeedSubscription(WebFeedSubscription wfs) {
    	
    	DatabaseManager.persist(new WebFeedSubscriptionJPA(wfs));
    	
    }
    
	@Override
    public void editWebFeedSubscription(WebFeedSubscription wfs) {
		EntityManager entitymanager = 
				DatabaseManager.getFactory().createEntityManager();
		entitymanager.getTransaction().begin();
		WebFeedSubscriptionJPA wfsjpa = entitymanager.find(WebFeedSubscriptionJPA.class, wfs.getName());
		wfsjpa.setSubscriptionName(wfs.getName());
		wfsjpa.setSubscriptionDescription(wfs.getDescription());
		wfsjpa.setPollinterval(wfs.getPollInterval());
		wfsjpa.setUrls(wfs.getUrls());;
    	entitymanager.getTransaction().commit();
    	entitymanager.close();
		
    }
    
	@Override
    public void deleteWebFeedSubscription(String s) throws DatabaseException {
    	
		EntityManager entitymanager = 
				DatabaseManager.getFactory().createEntityManager();
		entitymanager.getTransaction().begin();
    	WebFeedSubscriptionJPA wfsJPA = entitymanager.find(WebFeedSubscriptionJPA.class, s);
		if(wfsJPA == null) {
			throw new DatabaseException(DatabaseException.ENTRY_NOT_FOUND);
		} else {
			entitymanager.remove(wfsJPA);
		}
		entitymanager.getTransaction().commit();
		entitymanager.close();		
    }
    
	@Override
    public WebFeedSubscription getWebFeedSubscription(String s) throws DatabaseException, MalformedURLException {

		EntityManager entitymanager = 
				DatabaseManager.getFactory().createEntityManager();
		WebFeedSubscriptionJPA wfsJPA = null;
		wfsJPA = entitymanager.find(WebFeedSubscriptionJPA.class, s);
		entitymanager.close();
		if(wfsJPA == null) {
			throw new DatabaseException(DatabaseException.ENTRY_NOT_FOUND);
		} else {
			return wfsJPA.getWebFeedSubscription();
		}
		
    }

	@Override
    public List<WebFeedSubscription> getAllWebFeedSubscription() throws MalformedURLException {
		
		EntityManager entitymanager = 
				DatabaseManager.getFactory().createEntityManager();
		List<WebFeedSubscription> wfss = new ArrayList<WebFeedSubscription>();
		Query query = entitymanager.createQuery("SELECT e FROM WebFeedSubscriptionJPA e");
		List<WebFeedSubscriptionJPA> wfsJPAs = (List<WebFeedSubscriptionJPA>) query.getResultList();
		entitymanager.close();
		for(WebFeedSubscriptionJPA wfsJPA: wfsJPAs) {
			wfss.add(wfsJPA.getWebFeedSubscription());
		}
		return wfss;
		
    }
}
