/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 14/12/2013
 *
 */
package uoc.tfg.model.document;


public enum DocumentField {
	
	URL(1),
	TITLE(2),
	AUTHOR(3),
	DATE(4),
	KEYWORD(5),
	CONTENT(6),
	SUBJECT(7),
	DESCRIPTION(8),
	FORMAT(9),
	LANGUAGE(10),
	LOCATION(11);
	
	private final int value;
	
	
	DocumentField(int value) {
		this.value = value;
	}

	
	public int getValue() {
		return value;
	}
	
	public synchronized boolean is(DocumentField field){
		if(this.getValue() == field.getValue()) return true;
		else return false;
	}
	
	public synchronized boolean isnot(DocumentField field){
		if(this.getValue() != field.getValue()) return true;
		else return false;
	}
	
	
	public static DocumentField valueOf(int value) {
		switch(value) {
		case 1:
			return DocumentField.URL;
		case 2:
			return DocumentField.TITLE;
		case 3:
			return DocumentField.AUTHOR;
		case 4:
			return DocumentField.DATE;
		case 5:
			return DocumentField.KEYWORD;
		case 6:
			return DocumentField.CONTENT;
		case 7:
			return DocumentField.SUBJECT;
		case 8:
			return DocumentField.DESCRIPTION;
		case 9:
			return DocumentField.FORMAT;
		case 10:
			return DocumentField.LANGUAGE;
		case 11:
			return DocumentField.LOCATION;
		default:
			return null;
		}
	}
	
	
	public static DocumentField getValueOf(String value) {
		if(value.equals("url")) return DocumentField.URL;
		else if(value.equals("title")) return DocumentField.TITLE;
		else if(value.equals("author")) return DocumentField.AUTHOR;
		else if(value.equals("date")) return DocumentField.DATE;
		else if(value.equals("keyword")) return DocumentField.KEYWORD;
		else if(value.equals("content")) return DocumentField.CONTENT;
		else if(value.equals("subject")) return DocumentField.SUBJECT;
		else if(value.equals("description")) return DocumentField.DESCRIPTION;
		else if(value.equals("format")) return DocumentField.FORMAT;
		else if(value.equals("language")) return DocumentField.LANGUAGE;
		else if(value.equals("location")) return DocumentField.LOCATION;
		else return null;
	}
	
	
	@Override
	public String toString() {
		
		switch(this) {
			case URL:
				return "url";
			case TITLE:
				return "title";
			case AUTHOR:
				return "author";
			case DATE:
				return "date";
			case KEYWORD:
				return "keyword";
			case CONTENT:
				return "content";
			case SUBJECT:
				return "subject";
			case DESCRIPTION:
				return "description";
			case FORMAT:
				return "format";
			case LANGUAGE:
				return "language";
			case LOCATION:
				return "location";
			default:
				return "";
		}
	}
}