package uoc.tfg.model.document;

import java.io.File;
import java.io.IOException;
import java.util.List;

import org.apache.lucene.document.Document;
import org.apache.lucene.queryparser.classic.ParseException;

public interface IIndexHandler {

	public void createIndexWriter() throws IOException;

	public void addDocument(Document doc) throws IOException;

	public void deleteDocument(Document doc);

	public void updateDocument(Document doc);

	public List<Document> searchIndex(String[] fields, String[] queries, String[] logicals) throws ParseException, IOException;
	
	public List<Document> getAllDocuments() throws IOException;
	
	public int getNumDocuments() throws IOException;

	public void openDirectory(File path) throws IOException;
	
}
