package uoc.tfg.model.marketdata;


public enum DataType {

	Bardata(1),
	Tickdata(2),
	Quotedata(3);
	
	private final int value;
	
	/**
	 * Constructor
	 * @param value
	 */
	DataType(int value) {
		this.value = value;
	}
	
	/**
	 * 
	 * @return
	 */
	public int getValue() {
		return this.value;
	}
	
	
	/**
	 * 
	 * @param value
	 * @return
	 */
	public static DataType valueOf(int value) {
		switch(value) {
		case 1:
			return DataType.Bardata;
		case 2:
			return DataType.Tickdata;
		case 3:
			return DataType.Quotedata;
		default:
			return null;
		}
	}
	
	/**
	 * Text representation of a resolution data type
	 * @return
	 */
	@Override
	public String toString() {
		
		switch(this) {
			case Bardata:
				return "BarData";
			case Tickdata:
				return "TickData";
			case Quotedata:
				return "QuoteData";
			default:
				return "";
		}
		
	}
	
}
