package uoc.tfg.model.marketdata;

import java.io.Serializable;
import java.util.Date;
import java.util.List;


/*
 * Represents an index instrument
 */
public class Index extends Instrument implements Serializable{

	private static final long serialVersionUID = 1L;
	
	private InstrumentType type;
	
	private List<Instrument> instruments;
	
	
	public Index() {
		super();
	}
	
	public Index(String symbol, String name, String marketSymbol, 
			String marketCountry) {
		super(symbol, name, null, marketSymbol, marketCountry);
	}
	
	public Index(String symbol, String name, String marketSymbol, 
			String marketCountry, Date startDate, Date endDate, boolean canceled) {
		super(symbol, name, null, marketSymbol, marketCountry, startDate, endDate, canceled);
	}
	
	/**
	 * GETTERS
	 */
	public InstrumentType getInstrumentType() {
		return this.type;
	}
	
	public List<Instrument> getInstruments() {
		return this.instruments;
	}
	
	
	/**
	 * SETTERS
	 */
	public void setInstrumentType(InstrumentType type) {
		this.type = type;
	}
	
	public void setInstruments(List<Instrument> instruments) {
		this.instruments = instruments;
	}

}
