package uoc.tfg.model.marketdata;


/*
 * Enum class representing the instrument types
 */
public enum InstrumentType {

	STOCK(1),
	FUTURE(2),
	OPTION(3),
	FOREX(4);
	
	private final int value;
	
	/**
	 * Constructor
	 * @param value
	 */
	InstrumentType(int value) {
		this.value = value;
	}
	
	/**
	 * 
	 * @return
	 */
	public int getValue() {
		return this.value;
	}
	
	/**
	 * 
	 * @param value
	 * @return
	 */
	public static InstrumentType valueOf(int value) {
		switch(value) {
		case 1:
			return InstrumentType.STOCK;
		case 2:
			return InstrumentType.FUTURE;
		case 3:
			return InstrumentType.OPTION;
		case 4:
			return InstrumentType.FOREX;
		default:
			return null;
		}
	}
	
	/**
	 * 
	 * @return
	 */
	@Override
	public String toString() {
		
		switch(this) {
		case STOCK:
			return "Stock";
		case FUTURE:
			return "Future";
		case OPTION:
			return "Option";
		case FOREX:
			return "Forex";
		default:
			return "";
		}
		
	}
	
}
