package uoc.tfg.model.marketdata;

public enum PriceType {
	
	OPEN(1),
	MINIMUN(2),
	MAXIMUN(3),
	CLOSE(4);
	
	private final int value;
	
	/**
	 * Constructor
	 * @param value
	 */
	PriceType(int value) {
		this.value = value;
	}
	
	/**
	 * 
	 * @return
	 */
	public int getValue() {
		return this.value;
	}
	
	
	/**
	 * 
	 * @param value
	 * @return
	 */
	public static PriceType valueOf(int value) {
		switch(value) {
		case 1:
			return PriceType.OPEN;
		case 2:
			return PriceType.MINIMUN;
		case 3:
			return PriceType.MAXIMUN;
		case 4:
			return PriceType.CLOSE;
		default:
			return null;
		}
	}
	
	/**
	 * Text representation of an enum type
	 * @return
	 */
	@Override
	public String toString() {
		
		switch(this) {
		case OPEN:
			return "Open";
		case MINIMUN:
			return "Minimun";
		case MAXIMUN:
			return "Maximun";
		case CLOSE:
			return "Close";
		default:
			return null;
		}
		
	}
	
}
