package uoc.tfg.model.marketdata;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;

public class TimeSeriesConcurrentList extends ArrayList<TimeSeries> {

	private static final long serialVersionUID = 1L;
	
	private boolean bussy = false;
	
	public TimeSeriesConcurrentList(HashSet<Instrument> instruments) {
		super();
		Iterator<Instrument> itr = instruments.iterator();
		while(itr.hasNext())
			this.add(new TimeSeries(itr.next()));
	}
	
	public synchronized void setBussy(boolean bussy) {
		this.bussy = bussy;
	}
	
	public synchronized boolean isBussy() {
		return this.bussy;
	}
	
	public synchronized void waitConcurrentList() {
		try {
			wait();
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public synchronized void notifyConcurrentList() {
		notify();
	}

	public synchronized void notifyAllConcurrentList() {
		notifyAll();
	}

}
