package uoc.tfg.model.marketdata;

import java.sql.SQLException;

import uoc.tfg.model.Interval;



public interface TimeSeriesUpdater extends Runnable {

	public abstract void start();
	
	public abstract void stop();
	
	/**
	 * GETTERS
	 */
	
	public abstract Market getMarket();
	
	public abstract TimeSeriesConcurrentList getTimeSeries();
	
	public abstract DataType getSessionDataType();
	
	public abstract DataType getHistoricalDataType();
	
	public abstract DataType getSessionSourceDataType();
	
	public abstract DataType getHistoricalSourceDataType();
	
	public abstract Interval getSessionDataFrequency();
	
	public abstract Interval getHistoricalDataFrequency();
	
	public abstract MarketSession getUpdateStart();
	
	public abstract MarketSession getUpdateEnd();
	
	public abstract long getNextUpdate();
	
	public abstract long getStop();
	
	public abstract MarketSession getCurrentSession();
	
	/**
	 * SETTERS
	 */
	
	public abstract void setMarket(Market market);
	
	public abstract void setTimeSeriesCollection(TimeSeriesConcurrentList timeSeries);
	
	public abstract void setSessionDataType(DataType type);
	
	public abstract void setHistoricalDataType(DataType type);
	
	public abstract void setSessionSourceDataType(DataType type);
	
	public abstract void setHistoricalSourceDataType(DataType type);
	
	public abstract void setSessionDataFrequency(Interval frequency);
	
	public abstract void setHistoricalDataFrequency(Interval frequency);
	
	public abstract void setUpdateStart(MarketSession startSession);
	
	public abstract void setUpdateEnd(MarketSession endSession);
	
	public abstract void setNextUpdate(long nextUpdate);
	
	public abstract void setStop(long stop);
	
	
	
	public abstract UnitaryData pollTickData(
			Instrument instrument,  long nextUpdate, Interval frequency) throws SQLException;
	
	public abstract UnitaryData pollBarData(
			Instrument instrument,  long nextUpdate, Interval frequency) throws SQLException;

	public abstract void updateSessionBarTimeSeries() throws SQLException;
	
	public abstract void updateSessionTickTimeSeries() throws SQLException;

	public abstract void updateHistoricalBarTimeSeries() throws SQLException;
	
	public abstract void updateHistoricalTickTimeSeries() throws SQLException;

}
