/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 17/12/2013
 *
 */
package uoc.tfg.model.marketdata.lightstreamer;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Properties;

import uoc.tfg.gui.views.MessageDialog;

import com.lightstreamer.ls_client.ConnectionInfo;
import com.lightstreamer.ls_client.ExtendedTableInfo;
import com.lightstreamer.ls_client.SubscrException;

/*
 *
 */
public class AdapterInfoLS implements Serializable {
	
	private static final long serialVersionUID = -1773184980855283680L;
	
	public static Properties serverProperties;
	
	public static Properties itemsReferences;
	
	static {
		serverProperties = new Properties();
		itemsReferences = new Properties();
		InputStream in = null;		
		try {
			in = new FileInputStream("properties/marketdata/cotizaciones_me.properties");
			serverProperties.load(in);
			in.close();
			in = new FileInputStream("properties/marketdata/items_cotizaciones_me.properties");
			itemsReferences.load(in);
			in.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}		
	}

	
	private String adapterName = serverProperties.getProperty("ADAPTER_NAME");
	
	private String serverUrl = serverProperties.getProperty("URL");
	
	private String connectionAdapter = serverProperties.getProperty("CONNECTION_ADAPTER");
	
	private String[] items = new String[itemsReferences.size()];
	
	private String[] schema = {
			"precio_ultima_cotizacion", "variacion_porcentual", 
			"variacion_puntos", "maximo", "minimo", "volumen", 
			"fecha_hora_cotizacion"
			};
	
	private String dataAdapter = "FINFEED";
	
	private boolean snapshotSetting = false;
	
	private String subscriptionMode = "MERGE";
	
	private long delay;
		
	private ConnectionInfo cInfo;
	
	private ExtendedTableInfo tInfo;
	
	public AdapterInfoLS() {
		Object[] o = itemsReferences.keySet().toArray();
		for(int i = 0; i < itemsReferences.size(); i++){
			items[i] = o[i].toString();
		} 
		cInfo = new ConnectionInfo();
		cInfo.pushServerUrl = this.serverUrl;
		cInfo.adapter = this.connectionAdapter;
		try {
			tInfo = new ExtendedTableInfo(
					this.items, this.subscriptionMode, this.schema, this.snapshotSetting);
		} catch (SubscrException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		tInfo.setDataAdapter(this.dataAdapter);
	}
	
	public AdapterInfoLS(String adapterName, String url, String cAdapter, String[] items,
			String[] schema, String dAdapter, boolean snapshotSetting) throws SubscrException {
		this(adapterName, url, cAdapter, items, schema, dAdapter, snapshotSetting, null, 0);
	}
	
	public AdapterInfoLS(String adapterName, String url, String cAdapter, String[] items,
			String[] schema, String dAdapter, boolean snapshotSetting, 
			String subscriptionMode, long delay) throws SubscrException {
		this.adapterName = adapterName;
		cInfo = new ConnectionInfo();
		cInfo.pushServerUrl = url;
		cInfo.adapter = cAdapter;
		tInfo = new ExtendedTableInfo(items, subscriptionMode, schema, snapshotSetting);
		tInfo.setDataAdapter(dAdapter);
	}

	/**
	 * @return the adapterName
	 */
	public String getAdapterName() {
		return adapterName;
	}

	/**
	 * @param adapterName the adapterName to set
	 */
	public void setAdapterName(String adapterName) {
		this.adapterName = adapterName;
	}

	/**
	 * @return the serverUrl
	 */
	public String getServerUrl() {
		return serverUrl;
	}

	/**
	 * @param serverUrl the serverUrl to set
	 */
	public void setServerUrl(String serverUrl) {
		this.serverUrl = serverUrl;
	}

	/**
	 * @return the connectionAdapter
	 */
	public String getConnectionAdapter() {
		return connectionAdapter;
	}

	/**
	 * @param connectionAdapter the connectionAdapter to set
	 */
	public void setConnectionAdapter(String connectionAdapter) {
		this.connectionAdapter = connectionAdapter;
	}

	/**
	 * @return the items
	 */
	public String[] getItems() {
		return items;
	}

	/**
	 * @param items the items to set
	 */
	public void setItems(String[] items) {
		this.items = items;
	}

	/**
	 * @return the schema
	 */
	public String[] getSchema() {
		return schema;
	}

	/**
	 * @param schema the schema to set
	 */
	public void setSchema(String[] schema) {
		this.schema = schema;
	}

	/**
	 * @return the dataAdapter
	 */
	public String getDataAdapter() {
		return dataAdapter;
	}

	/**
	 * @param dataAdapter the dataAdapter to set
	 */
	public void setDataAdapter(String dataAdapter) {
		this.dataAdapter = dataAdapter;
	}

	/**
	 * @return the snapshotSetting
	 */
	public boolean isSnapshotSetting() {
		return snapshotSetting;
	}

	/**
	 * @param snapshotSetting the snapshotSetting to set
	 */
	public void setSnapshotSetting(boolean snapshotSetting) {
		this.snapshotSetting = snapshotSetting;
	}

	/**
	 * @return the subscriptionMode
	 */
	public String getSubscriptionMode() {
		return subscriptionMode;
	}

	/**
	 * @param subscriptionMode the subscriptionMode to set
	 */
	public void setSubscriptionMode(String subscriptionMode) {
		this.subscriptionMode = subscriptionMode;
	}

	/**
	 * @return the delay
	 */
	public long getDelay() {
		return delay;
	}

	/**
	 * @param delay the delay to set
	 */
	public void setDelay(long delay) {
		this.delay = delay;
	}

	/**
	 * @return the cInfo
	 */
	public ConnectionInfo getcInfo() {
		return cInfo;
	}

	/**
	 * @param cInfo the cInfo to set
	 */
	public void setcInfo(ConnectionInfo cInfo) {
		this.cInfo = cInfo;
	}

	/**
	 * @return the tInfo
	 */
	public ExtendedTableInfo gettInfo() {
		return tInfo;
	}

	/**
	 * @param tInfo the tInfo to set
	 */
	public void settInfo(ExtendedTableInfo tInfo) {
		this.tInfo = tInfo;
	}

}
