package uoc.tfg.model.marketdata.yahoo;

import java.io.BufferedReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import uoc.tfg.gui.views.MessageDialog;

public class ServerAdapterYahoo {
	
	private DownloadYahooInfo info;
	
	public ServerAdapterYahoo(DownloadYahooInfo info) {
		this.info = info;
	}
	
	
	/**
	 * Method connecting with the data provider
	 * @param url
	 * @param symbol
	 */
	public void connectDatabase() {
		HttpURLConnection conn = null;
		try {
			conn = (HttpURLConnection)this.constructURL().openConnection();
			conn.connect();
		} catch (IOException e) {
			new MessageDialog(e);
		}
		try {
				
			InputStreamReader in = new InputStreamReader((InputStream)conn.getContent());
				
			BufferedReader buff = new BufferedReader(in);
			String line;
			StringBuffer text = new StringBuffer();
			while ((line = buff.readLine()) != null) { 
				text.append(line + "\n");
			} 
			FileWriter file = new FileWriter(".\\"+info.getSymbol());
			file.write(text.toString());
			file.close();
		} catch (IOException e) {
			new MessageDialog(e);
		}
	}
	
	/**
	 * Method to construct the URL
	 */
	public URL constructURL() {
		
		URL url = null;
		try {
			url = new URL("http://ichart.finance.yahoo.com/table.csv" + 
					"?s=" + info.getSymbol() + 
					this.info.getStartDate() + 
					this.info.getEndDate() +
					"&g="+ info.getFrequency().charAt(0) +
					"&ignore=.csv");
					
		} catch (MalformedURLException e) {
			new MessageDialog(e);
		}
		
		return url;
	}
	
}
