/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 14/12/2013
 *
 */
package uoc.tfg.model.news;

import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.text.ParseException;
import java.util.List;

import org.apache.lucene.document.Document;
import org.apache.tika.exception.TikaException;
import org.xml.sax.SAXException;

/*
 *
 */
public interface IWebContentParser {
	
	public InputStream getImputStream(URL url) throws IOException;
	
	public WebContent getWebContent(URL url) throws IOException, ParseException;
	
	public Document getDocument(URL url) throws IOException, SAXException, TikaException, ParseException;

	public List<URL> findLinksInContent(URL url) throws IOException;
	
	public int getPriority(WebContent content);
}
