/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 02/12/2013
 *
 */
package uoc.tfg.model.news;

import java.io.Serializable;
import java.net.URL;
import java.util.Date;

/*
 *
 */
public class WebContent implements Serializable{
	
	private static final long serialVersionUID = -5962418288873918640L;

	private URL url;
	
	private String title = "";
	
	private WebContentFormat format;
	
	private Date lastModified;
	
	private String content = "";

	
	public WebContent(URL url, String title, WebContentFormat format, 
			Date lastModified, String content) {
		this.url = url;
		if(this.title !=null) this.title = title;
		this.format = format;
		this.lastModified = lastModified;
		if(this.content !=null) this.content = content;
	}


	/**
	 * @return the url
	 */
	public URL getUrl() {
		return url;
	}


	/**
	 * @param url the url to set
	 */
	public void setUrl(URL url) {
		this.url = url;
	}


	/**
	 * @return the title
	 */
	public String getTitle() {
		return title;
	}


	/**
	 * @param title the title to set
	 */
	public void setTitle(String title) {
		this.title = title;
	}


	/**
	 * @return the format
	 */
	public WebContentFormat getFormat() {
		return format;
	}


	/**
	 * @param format the format to set
	 */
	public void setFormat(WebContentFormat format) {
		this.format = format;
	}

	/**
	 * @return the lastModified
	 */
	public Date getLastModified() {
		return lastModified;
	}


	/**
	 * @param lastModified the lastModified to set
	 */
	public void setLastModified(Date lastModified) {
		this.lastModified = lastModified;
	}


	/**
	 * @return the content
	 */
	public String getContent() {
		return content;
	}


	/**
	 * @param content the content to set
	 */
	public void setContent(String content) {
		this.content = content;
	}
	
		
}
