/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 02/12/2013
 *
 */
package uoc.tfg.model.news;

public enum WebContentFormat {
	
	HTML(1),
	XML(2);
	
	private final int value;
	
	/**
	 * Constructor
	 * @param value
	 */
	WebContentFormat(int value) {
		this.value = value;
	}

	/**
	 * @return the value
	 */
	public int getValue() {
		return value;
	}
	
	public static WebContentFormat getValueOf(String value) {
		if(value.equals("txt/html")) return WebContentFormat.HTML;
		else if(value == "xml") return WebContentFormat.XML;
		else return null;
	}
	
	@Override
	public String toString() {
		
		switch(this) {
			case HTML:
				return "txt/html";
			case XML:
				return "xml";
			default:
				return "";
		}
	}


}
