package uoc.tfg.model.news.webcrawler;

import java.util.List;
import java.util.Queue;

import uoc.tfg.exception.WebCrawlingException;
import uoc.tfg.model.Status;
import uoc.tfg.model.news.WebContent;


/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 02/12/2013
 *
 */


/*
 *
 */
public interface IWebCrawler extends Runnable {
	
	public String getName();
	
	public Status getStatus();
	
	public void setStatus(Status status);
	
	public void startWebCrawler() throws WebCrawlingException;
	
	public void pauseWebCrawler();
	
	public void resumeWebCrawler();
	
	public void stopWebCrawler();

	public int getNumVisitedUrls();

	public void setNumVisitedUrls(int numVisitedUrls);

	public List<WebContent> getAllEntries();

	public Queue<WebContent> getLastEntries();

}
