/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 02/12/2013
 *
 */
package uoc.tfg.model.news.webcrawler;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.PriorityQueue;
import java.util.Queue;

/*
 *
 */
public class WebCrawlingSeed implements Serializable{

	private static final long serialVersionUID = 3306125621454956652L;

	private String name;
	private String description;
	private Queue<WebCrawlingURL> urls;
	
	public WebCrawlingSeed() {
		this(null,null,new ArrayList<WebCrawlingURL>());
	}
	
	public WebCrawlingSeed(String name, String description, List<WebCrawlingURL> urls) {
		this.name = name;
		this.description = description;
		this.setURLs(urls);
	}
	
	public WebCrawlingSeed(String name, String description, Queue<WebCrawlingURL> urls) {
		this.name = name;
		this.description = description;
		this.urls = urls;
	}
	
	
	/**
	 * @return the name
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param name the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @return the description
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * @param description the description to set
	 */
	public void setDescription(String description) {
		this.description = description;
	}

	/**
	 * @return the urls
	 */
	public Queue<WebCrawlingURL> getUrls() {
		return urls;
	}
	
	public List<WebCrawlingURL> getURLs() {
		List<WebCrawlingURL> urls = new ArrayList<WebCrawlingURL>();
		urls.addAll(this.urls);
		return urls;
	}

	/**
	 * @param urls the urls to set
	 */
	public void setUrls(Queue<WebCrawlingURL> urls) {
		this.urls = urls;
	}
	
	public void setURLs(List<WebCrawlingURL> urls) {
		
		Queue<WebCrawlingURL> pq = new PriorityQueue<WebCrawlingURL>();
		for(WebCrawlingURL u: urls) {
			pq.add(u);
		}
		this.urls = pq;		
	}
	
}
