/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 19/12/2013
 *
 */
package uoc.tfg.model.news.webcrawler;

import uoc.tfg.model.news.IWebContentParser;


/*
 *
 */
public class WebCrawlingSimpleStrategy implements IWebCrawlingStrategy {

	private String strategyName;
	private String description;
	private int maxNumUrl;
	private int maxDepth;
	private String algorithm;
	private long delay;
	private WebCrawlingSeed seed;
	private IWebContentParser contentParser;
	
	/**
	 * Constructors
	 */
	public WebCrawlingSimpleStrategy() {
		super();
	}

	/**
	 * @param strategyName
	 * @param description
	 * @param maxNumUrl
	 * @param maxDepth
	 * @param algorithm
	 * @param delay
	 * @param seed
	 */
	public WebCrawlingSimpleStrategy(String strategyName, String description, int maxNumUrl, 
			int maxDepth, String algorithm, long delay, WebCrawlingSeed seed, 
			IWebContentParser contentParser) {
		this.strategyName = strategyName;
		this.description = description;
		this.maxNumUrl = maxNumUrl;
		this.maxDepth = maxDepth;
		this.algorithm = algorithm;
		this.delay = delay;
		this.seed = seed;
		this.setContentParser(contentParser);
	}

	public WebCrawlingURL getNextUrl() {
		return this.getSeed().getUrls().poll();
	}
	/**
	 * @return the strategyName
	 */
	@Override
	public String getStrategyName() {
		return strategyName;
	}

	/**
	 * @param strategyName the strategyName to set
	 */
	@Override
	public void setStrategyName(String strategyName) {
		this.strategyName = strategyName;
	}

	/**
	 * @return the description
	 */
	@Override
	public String getDescription() {
		return description;
	}

	/**
	 * @param description the description to set
	 */
	@Override
	public void setDescription(String description) {
		this.description = description;
	}

	/**
	 * @return the maxNumUrl
	 */
	@Override
	public int getMaxNumUrl() {
		return maxNumUrl;
	}

	/**
	 * @param maxNumUrl the maxNumUrl to set
	 */
	@Override
	public void setMaxNumUrl(int maxNumUrl) {
		this.maxNumUrl = maxNumUrl;
	}

	/**
	 * @return the maxDepth
	 */
	@Override
	public int getMaxDepth() {
		return maxDepth;
	}

	/**
	 * @param maxDepth the maxDepth to set
	 */
	@Override
	public void setMaxDepth(int maxDepth) {
		this.maxDepth = maxDepth;
	}

	/**
	 * @return the algorithm
	 */
	@Override
	public String getAlgorithm() {
		return algorithm;
	}

	/**
	 * @param algorithm the algorithm to set
	 */
	@Override
	public void setAlgorithm(String algorithm) {
		this.algorithm = algorithm;
	}

	/**
	 * @return the delay
	 */
	@Override
	public long getDelay() {
		return delay;
	}

	/**
	 * @param delay the delay to set
	 */
	@Override
	public void setDelay(long delay) {
		this.delay = delay;
	}

	/**
	 * @return the seed
	 */
	@Override
	public WebCrawlingSeed getSeed() {
		return seed;
	}

	/**
	 * @param seed the seed to set
	 */
	@Override
	public void setSeed(WebCrawlingSeed seed) {
		this.seed = seed;
	}

	/**
	 * @return
	 */
	@Override
	public boolean exitCriteria(IWebCrawler wc) {
		
		if((wc.getNumVisitedUrls() <= this.maxNumUrl) && !this.seed.getUrls().isEmpty()) {
			return false;
		} else {
			return true;
		}
		
	}

	/**
	 * @return the contentParser
	 */
	@Override
	public IWebContentParser getContentParser() {
		return contentParser;
	}

	/**
	 * @param contentParser the contentParser to set
	 */
	@Override
	public void setContentParser(IWebContentParser contentParser) {
		this.contentParser = contentParser;
	}

}
