/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 12/11/2013
 *
 */
package uoc.tfg.model.news.webfeed;

/*
 *
 */
public enum WebFeedFormat {
	
	RSS091(1),
	RSS09(2),
	RSS10(3),
	RSS20(4),
	ATOM(5);
	
	private final int value;
	
	/**
	 * Constructor
	 * @param value
	 */
	WebFeedFormat(int value) {
		this.value = value;
	}

	/**
	 * @return the value
	 */
	public int getValue() {
		return value;
	}
	
	public static WebFeedFormat getValueOf(String value) {
		if(value.equals("RSS 0.91")) return WebFeedFormat.RSS091;
		else if(value.equals("RSS 0.90")) return WebFeedFormat.RSS09;
		else if(value.equals("RSS 1.0")) return WebFeedFormat.RSS10;
		else if(value.equals("RSS 2.0")) return WebFeedFormat.RSS20;
		else if(value.equals("Atom")) return WebFeedFormat.ATOM;
		else return null;
	}
	
	@Override
	public String toString() {
		
		switch(this) {
			case RSS091:
				return "RSS 0.91";
			case RSS09:
				return "RSS 0.90";
			case RSS10:
				return "RSS 1.0";
			case RSS20:
				return "RSS 2.0";
			case ATOM:
				return "Atom";
			default:
				return "";
		}
	}

}
