/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 12/11/2013
 *
 */
package uoc.tfg.model.news.webfeed;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import uoc.tfg.model.Status;
import uoc.tfg.model.news.WebContent;


/*
 *
 */
public class WebFeedSubscription implements Serializable {
	
	private static final long serialVersionUID = 8725422432136384602L;
	private String name;
	private String description;
	private List<WebFeedURL> providers;
	private long pollInterval;

	public WebFeedSubscription() {
		this(null,null,null,0);
	}
		
	public WebFeedSubscription(String name, String description, List<WebFeedURL> urls, long pollInterval) {
		this.setName(name);
		this.setDescription(description);
		this.providers = new ArrayList<WebFeedURL>();
		this.setUrls(urls);
		this.setPollInterval(pollInterval);
	}
	

	/**
	 * @return the name
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param name the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @return the description
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * @param description the description to set
	 */
	public void setDescription(String description) {
		this.description = description;
	}

	/**
	 * @return the urls
	 */
	public List<WebFeedURL> getUrls() {
		return providers;
	}

	/**
	 * @param urls the urls to set
	 */
	public void setUrls(List<WebFeedURL> urls) {
		this.providers = urls;
	}

	/**
	 * @return the pollInterval
	 */
	public long getPollInterval() {
		return pollInterval;
	}

	/**
	 * @param pollInterval the pollInterval to set
	 */
	public void setPollInterval(long pollInterval) {
		this.pollInterval = pollInterval;
	}

	/**
	 * @param string
	 * @return
	 */
	public boolean isRelevant(WebContent wc) {
		// TODO Auto-generated method stub
		return true;
	}

}
