/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 08/01/2014
 *
 */
package uoc.tfg.model.news.webfeed;

import java.io.Serializable;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Date;


public class WebFeedURL implements Serializable {
	
	private static final long serialVersionUID = -3176032055846605368L;
	private URL url;
	private String name;
	private String description;
	private WebFeedFormat webFeedformat;
	private Date lastPoll;
	
	public WebFeedURL() throws MalformedURLException {
		this("http://", null, null, null, new Date(0));
	}
	
	public WebFeedURL(String url, String name, String description, WebFeedFormat format, Date lastPoll) throws MalformedURLException {
		this(new URL(url), name, description, format, lastPoll);
	}
	
	public WebFeedURL(URL url, String name, String description, WebFeedFormat format, Date lastPoll) throws MalformedURLException {
		this.setUrl(url);
		this.setName(name);
		this.setDescription(description);
		this.setWebFeedformat(format);
		this.lastPoll = lastPoll;
	}


	/**
	 * @return the url
	 */
	public URL getUrl() {
		return url;
	}
	
	/**
	 * @return the url
	 */
	public String getUrlText() {
		return url.toString();
	}

	/**
	 * @param url the url to set
	 */
	public void setUrl(URL url) {
		this.url = url;
	}
	
	/**
	 * @return the name
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param name the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @return the description
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * @param description the description to set
	 */
	public void setDescription(String description) {
		this.description = description;
	}

	/**
	 * @return the webFeedformat
	 */
	public WebFeedFormat getWebFeedformat() {
		return webFeedformat;
	}

	/**
	 * @param webFeedformat the webFeedformat to set
	 */
	public void setWebFeedformat(WebFeedFormat webFeedformat) {
		this.webFeedformat = webFeedformat;
	}

	/**
	 * @return the lastPoll
	 */
	public Date getLastPoll() {
		return lastPoll;
	}

	/**
	 * @param lastPoll the lastPoll to set
	 */
	public void setLastPoll() {
		this.lastPoll.setTime(System.currentTimeMillis());
	}

	/**
	 * @param lastPoll
	 */
	public void setLastPoll(Date lastPoll) {
		this.lastPoll = lastPoll;
	}

}
