/**
 * TFG-UOC
 * 
 * @author Javier Sanzol
 * 
 * 08/01/2014
 *
 */
package uoc.tfg.model.textanalysis;

import java.util.Vector;

import org.apache.lucene.analysis.util.CharArraySet;
import org.apache.lucene.util.Version;

/**
 * 
 * StopWord
 */

public class StopWord {
	
	private static final String [] googleSpanishStopWorlds = {
		"y", "un", "una", "unas", "unos", "uno", "sobre", 
		"todo", "tambin", "tras", "otro", "algn", 
		"alguno", "alguna", "algunos", "algunas", "ser", 
		"es", "soy", "eres", "somos", "sois", "estoy", 
		"esta", "estamos", "estais", "estan", "como", 
		"en", "para", "atras", "porque", "por", "qu", 
		"estado", "estaba", "ante", "antes", "siendo", 
		"ambos", "pero", "por", "poder", "puede", "puedo", 
		"podemos", "podeis", "pueden", "fui", "fue", 
		"fuimos", "fueron", "hacer", "hago", "hace", 
		"hacemos", "haceis", "hacen", "cada", "fin", 
		"incluso", "primero", "desde", "conseguir", 
		"consigo", "consigue", "consigues", "conseguimos", 
		"consiguen", "ir", "voy", "va", "vamos", "vais", 
		"van", "vaya", "gueno", "ha", "tener", "tengo", 
		"tiene", "tenemos", "teneis", "tienen", "el", 
		"la", "lo", "las", "los", "su", "aqui", "mio", 
		"tuyo", "ellos", "ellas", "nos", "nosotros", 
		"vosotros", "vosotras", "si", "dentro", "solo", 
		"solamente", "saber", "sabes", "sabe", "sabemos", 
		"sabeis", "saben", "ultimo", "largo", "bastante", 
		"haces", "muchos", "aquellos", "aquellas", "sus", 
		"entonces", "tiempo", "verdad", "verdadero", "verdadera", 
		"cierto", "ciertos", "cierta", "ciertas", "intentar", 
		"intento", "intenta", "intentas", "intentamos", 
		"intentais", "intentan", "dos", "bajo", "arriba", 
		"encima", "usar", "uso", "usas", "usa", "usamos", 
		"usais", "usan", "emplear", "empleo", "empleas", 
		"emplean", "ampleamos", "empleais", "valor", "muy", 
		"era", "eras", "eramos", "eran", "modo", "bien", "cual", 
		"cuando", "donde", "mientras", "quien", "con", "entre", 
		"sin", "trabajo", "trabajar", "trabajas", "trabaja", 
		"trabajamos", "trabajais", "trabajan", "podria", "podrias", 
		"podriamos", "podrian", "podriais", "yo", "aquel"};
	
	private static final String [] googleEnglishStopWorlds = {
		"a", "about", "above", "after", "again", "against", "all", 
		"am", "an", "and", "any", "are", "aren't", "as", "at", "be", 
		"because", "been", "before", "being", "below", "between", 
		"both", "but", "by", "can't", "cannot", "could", "couldn't", 
		"did", "didn't", "do", "does", "doesn't", "doing", "don't", 
		"down", "during", "each", "few", "for", "from", "further", 
		"had", "hadn't", "has", "hasn't", "have", "haven't", "having", 
		"he", "he'd", "he'll", "he's", "her", "here", "here's", "hers", 
		"herself", "him", "himself", "his", "how", "how's", "i", "i'd", 
		"i'll", "i'm", "i've", "if", "in", "into", "is", "isn't", "it", 
		"it's", "its", "itself", "let's", "me", "more", "most", "mustn't", 
		"my", "myself", "no", "nor", "not", "of", "off", "on", "once", 
		"only", "or", "other", "ought", "our", "ours", "ourselves", 
		"out", "over", "own", "same", "shan't", "she", "she'd", "she'll", 
		"she's", "should", "shouldn't", "so", "some", "such", "than", 
		"that", "that's", "the", "their", "theirs", "them", "themselves", 
		"then", "there", "there's", "these", "they", "they'd", "they'll", 
		"they're", "they've", "this", "those", "through", "to", "too", 
		"under", "until", "up", "very", "was", "wasn't", "we", "we'd", 
		"we'll", "we're", "we've", "were", "weren't", "what", "what's", 
		"when", "when's", "where", "where's", "which", "while", "who", 
		"who's", "whom", "why", "why's", "with", "won't", "would", "wouldn't", 
		"you", "you'd", "you'll", "you're", "you've", "your", "yours", 
		"yourself", "yourselves"};

	
	public static CharArraySet getGoogleSpanish() {
		Vector<String> l = new Vector<String>();
		l.copyInto(googleSpanishStopWorlds);
		return new CharArraySet(Version.LUCENE_46, l, true);
	}
	
	public static CharArraySet getGoogleEnglish() {
		Vector<String> l = new Vector<String>();
		l.copyInto(googleEnglishStopWorlds);
		return new CharArraySet(Version.LUCENE_46, l, true);
	}
}
