package uoc.tfg.model.textanalysis.classification;

import java.io.Serializable;
import java.util.Arrays;

public class CategorySet implements Serializable {
	
	private static final long serialVersionUID = 2040168782400192838L;
	
	private String name;
	
	private String description;
	
	private Category[] classes;

	public CategorySet() {
		
	}

	public CategorySet(String name, String description, Category[] classes) {
		this.name = name;
		this.description = description;
		this.classes = classes;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public Category[] getCategories() {
		return classes;
	}

	public void setCategories(Category[] classes) {
		this.classes = classes;
	}
	
	public void addCategory(Category c, int i) {
		this.classes[i] = c;
	}
	
	public String[] getCategoryNames() {
		
		String[] s = new String[this.classes.length];
		for(Category c: this.classes) {
			s[Arrays.asList(this.classes).indexOf(c)] = c.getName();
		}
		return s;
	}

}
